﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace <%= projectName %>.EntityFrameworkCore.Seed.Host
{
    public class DefaultDataInitialization
    {
        private readonly <%= projectName %>DbContext _context;

        public DefaultDataInitialization(<%= projectName %>DbContext context)
        {
            _context = context;
        }

        public void Create()
        {
            CreateData();
        }

        private void CreateData()
        {
            CountriesInitialization();
            StatesInitialization();
            CitiesInitialization();
        }

        private void CountriesInitialization()
        {
            if (!_context.Countries.Any(x => x.Id == "MEX"))
            {
                _context.Countries.Add(new Domain.Country() { Id = "MEX", Name = "Mexico", Abreviation = "MEX", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "USA", Name = "Estados Unidos de América", Abreviation = "USA", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "DEU", Name = "Alemania", Abreviation = "DEU", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "ITA", Name = "Italia", Abreviation = "ITA", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "CAN", Name = "Canadá", Abreviation = "CAN", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "FRA", Name = "Francia", Abreviation = "FRA", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "BRA", Name = "Brasil", Abreviation = "BRA", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "ARG", Name = "Argentina", Abreviation = "ARG", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "BEL", Name = "Bélgica", Abreviation = "BEL", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "BGR", Name = "Bulgaria", Abreviation = "BGR", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "CHL", Name = "Chile", Abreviation = "CHL", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "COL", Name = "Colombia", Abreviation = "COL", IsActive = true });
                _context.Countries.Add(new Domain.Country() { Id = "ECU", Name = "Ecuador", Abreviation = "ECU", IsActive = true });
            }
            _context.SaveChanges();
        }

        private void StatesInitialization()
        {
            if (!_context.States.Any(x => x.Id == "01"))
            {
                _context.States.AddRange(
                    new Domain.State() { Id = "01", Name = "Aguascalientes", Abreviation = "Ags.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "02", Name = "Baja California", Abreviation = "BC", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "03", Name = "Baja California Sur", Abreviation = "BCS", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "04", Name = "Campeche", Abreviation = "Camp.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "05", Name = "Coahuila de Zaragoza", Abreviation = "Coah.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "06", Name = "Colima", Abreviation = "Col.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "07", Name = "Chiapas", Abreviation = "Chis.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "08", Name = "Chihuahua", Abreviation = "Chih.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "09", Name = "Ciudad de México", Abreviation = "CDMX", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "10", Name = "Durango", Abreviation = "Dgo.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "11", Name = "Guanajuato", Abreviation = "Gto.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "12", Name = "Guerrero", Abreviation = "Gro.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "13", Name = "Hidalgo", Abreviation = "Hgo.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "14", Name = "Jalisco", Abreviation = "Jal.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "15", Name = "México", Abreviation = "Mex.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "16", Name = "Michoacán de Ocampo", Abreviation = "Mich.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "17", Name = "Morelos", Abreviation = "Mor.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "18", Name = "Nayarit", Abreviation = "Nay.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "19", Name = "Nuevo León", Abreviation = "NL", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "20", Name = "Oaxaca", Abreviation = "Oax.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "21", Name = "Puebla", Abreviation = "Pue.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "22", Name = "Querétaro", Abreviation = "Qro.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "23", Name = "Quintana Roo", Abreviation = "Q. Roo", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "24", Name = "San Luis Potosí", Abreviation = "SLP", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "25", Name = "Sinaloa", Abreviation = "Sin.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "26", Name = "Sonora", Abreviation = "Son.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "27", Name = "Tabasco", Abreviation = "Tab.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "28", Name = "Tamaulipas", Abreviation = "Tamps.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "29", Name = "Tlaxcala", Abreviation = "Tlax.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "30", Name = "Veracruz de Ignacio de la Llave", Abreviation = "Ver.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "31", Name = "Yucatán", Abreviation = "Yuc.", IsActive = true, CountryId = "MEX" },
                    new Domain.State() { Id = "32", Name = "Zacatecas", Abreviation = "Zac.", IsActive = true, CountryId = "MEX" }
                );
            }
            _context.SaveChanges();
        }

        private void CitiesInitialization()
        {
            if (!_context.Cities.Any(x => x.Id == "01001"))
            {
                _context.Cities.AddRange(
                    new Domain.City() { Id = "01001", Name = "Aguascalientes", Abreviation = "Aguascalientes", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01002", Name = "Asientos", Abreviation = "Asientos", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01003", Name = "Calvillo", Abreviation = "Calvillo", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01004", Name = "Cosío", Abreviation = "Cosío", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01005", Name = "Jesús María", Abreviation = "Jesús María", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01006", Name = "Pabellón de Arteaga", Abreviation = "Pabellón de Arteaga", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01007", Name = "Rincón de Romos", Abreviation = "Rincón de Romos", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01008", Name = "San José de Gracia", Abreviation = "San José de Gracia", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01009", Name = "Tepezalá", Abreviation = "Tepezalá", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01010", Name = "El Llano", Abreviation = "El Llano", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "01011", Name = "San Francisco de los Romo", Abreviation = "San Francisco de los Romo", IsActive = true, StateId = "01" },
                    new Domain.City() { Id = "02001", Name = "Ensenada", Abreviation = "Ensenada", IsActive = true, StateId = "02" },
                    new Domain.City() { Id = "02002", Name = "Mexicali", Abreviation = "Mexicali", IsActive = true, StateId = "02" },
                    new Domain.City() { Id = "02003", Name = "Tecate", Abreviation = "Tecate", IsActive = true, StateId = "02" },
                    new Domain.City() { Id = "02004", Name = "Tijuana", Abreviation = "Tijuana", IsActive = true, StateId = "02" },
                    new Domain.City() { Id = "02005", Name = "Playas de Rosarito", Abreviation = "Playas de Rosarito", IsActive = true, StateId = "02" },
                    new Domain.City() { Id = "03001", Name = "Comondú", Abreviation = "Comondú", IsActive = true, StateId = "03" },
                    new Domain.City() { Id = "03002", Name = "Mulegé", Abreviation = "Mulegé", IsActive = true, StateId = "03" },
                    new Domain.City() { Id = "03003", Name = "La Paz", Abreviation = "La Paz", IsActive = true, StateId = "03" },
                    new Domain.City() { Id = "03008", Name = "Los Cabos", Abreviation = "Los Cabos", IsActive = true, StateId = "03" },
                    new Domain.City() { Id = "03009", Name = "Loreto", Abreviation = "Loreto", IsActive = true, StateId = "03" },
                    new Domain.City() { Id = "04001", Name = "Calkiní", Abreviation = "Calkiní", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04002", Name = "Campeche", Abreviation = "Campeche", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04003", Name = "Carmen", Abreviation = "Carmen", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04004", Name = "Champotón", Abreviation = "Champotón", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04005", Name = "Hecelchakán", Abreviation = "Hecelchakán", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04006", Name = "Hopelchén", Abreviation = "Hopelchén", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04007", Name = "Palizada", Abreviation = "Palizada", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04008", Name = "Tenabo", Abreviation = "Tenabo", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04009", Name = "Escárcega", Abreviation = "Escárcega", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04010", Name = "Calakmul", Abreviation = "Calakmul", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "04011", Name = "Candelaria", Abreviation = "Candelaria", IsActive = true, StateId = "04" },
                    new Domain.City() { Id = "05001", Name = "Abasolo", Abreviation = "Abasolo", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05002", Name = "Acuña", Abreviation = "Acuña", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05003", Name = "Allende", Abreviation = "Allende", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05004", Name = "Arteaga", Abreviation = "Arteaga", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05005", Name = "Candela", Abreviation = "Candela", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05006", Name = "Castaños", Abreviation = "Castaños", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05007", Name = "Cuatro Ciénegas", Abreviation = "Cuatro Ciénegas", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05008", Name = "Escobedo", Abreviation = "Escobedo", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05009", Name = "Francisco I. Madero", Abreviation = "Francisco I. Madero", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05010", Name = "Frontera", Abreviation = "Frontera", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05011", Name = "General Cepeda", Abreviation = "General Cepeda", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05012", Name = "Guerrero", Abreviation = "Guerrero", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05013", Name = "Hidalgo", Abreviation = "Hidalgo", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05014", Name = "Jiménez", Abreviation = "Jiménez", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05015", Name = "Juárez", Abreviation = "Juárez", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05016", Name = "Lamadrid", Abreviation = "Lamadrid", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05017", Name = "Matamoros", Abreviation = "Matamoros", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05018", Name = "Monclova", Abreviation = "Monclova", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05019", Name = "Morelos", Abreviation = "Morelos", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05020", Name = "Múzquiz", Abreviation = "Múzquiz", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05021", Name = "Nadadores", Abreviation = "Nadadores", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05022", Name = "Nava", Abreviation = "Nava", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05023", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05024", Name = "Parras", Abreviation = "Parras", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05025", Name = "Piedras Negras", Abreviation = "Piedras Negras", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05026", Name = "Progreso", Abreviation = "Progreso", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05027", Name = "Ramos Arizpe", Abreviation = "Ramos Arizpe", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05028", Name = "Sabinas", Abreviation = "Sabinas", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05029", Name = "Sacramento", Abreviation = "Sacramento", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05030", Name = "Saltillo", Abreviation = "Saltillo", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05031", Name = "San Buenaventura", Abreviation = "San Buenaventura", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05032", Name = "San Juan de Sabinas", Abreviation = "San Juan de Sabinas", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05033", Name = "San Pedro", Abreviation = "San Pedro", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05034", Name = "Sierra Mojada", Abreviation = "Sierra Mojada", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05035", Name = "Torreón", Abreviation = "Torreón", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05036", Name = "Viesca", Abreviation = "Viesca", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05037", Name = "Villa Unión", Abreviation = "Villa Unión", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "05038", Name = "Zaragoza", Abreviation = "Zaragoza", IsActive = true, StateId = "05" },
                    new Domain.City() { Id = "06001", Name = "Armería", Abreviation = "Armería", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06002", Name = "Colima", Abreviation = "Colima", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06003", Name = "Comala", Abreviation = "Comala", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06004", Name = "Coquimatlán", Abreviation = "Coquimatlán", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06005", Name = "Cuauhtémoc", Abreviation = "Cuauhtémoc", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06006", Name = "Ixtlahuacán", Abreviation = "Ixtlahuacán", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06007", Name = "Manzanillo", Abreviation = "Manzanillo", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06008", Name = "Minatitlán", Abreviation = "Minatitlán", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06009", Name = "Tecomán", Abreviation = "Tecomán", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "06010", Name = "Villa de Álvarez", Abreviation = "Villa de Álvarez", IsActive = true, StateId = "06" },
                    new Domain.City() { Id = "07001", Name = "Acacoyagua", Abreviation = "Acacoyagua", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07002", Name = "Acala", Abreviation = "Acala", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07003", Name = "Acapetahua", Abreviation = "Acapetahua", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07004", Name = "Altamirano", Abreviation = "Altamirano", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07005", Name = "Amatán", Abreviation = "Amatán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07006", Name = "Amatenango de la Frontera", Abreviation = "Amatenango de la Frontera", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07007", Name = "Amatenango del Valle", Abreviation = "Amatenango del Valle", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07008", Name = "Angel Albino Corzo", Abreviation = "Angel Albino Corzo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07009", Name = "Arriaga", Abreviation = "Arriaga", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07010", Name = "Bejucal de Ocampo", Abreviation = "Bejucal de Ocampo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07011", Name = "Bella Vista", Abreviation = "Bella Vista", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07012", Name = "Berriozábal", Abreviation = "Berriozábal", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07013", Name = "Bochil", Abreviation = "Bochil", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07014", Name = "El Bosque", Abreviation = "El Bosque", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07015", Name = "Cacahoatán", Abreviation = "Cacahoatán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07016", Name = "Catazajá", Abreviation = "Catazajá", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07017", Name = "Cintalapa", Abreviation = "Cintalapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07018", Name = "Coapilla", Abreviation = "Coapilla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07019", Name = "Comitán de Domínguez", Abreviation = "Comitán de Domínguez", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07020", Name = "La Concordia", Abreviation = "La Concordia", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07021", Name = "Copainalá", Abreviation = "Copainalá", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07022", Name = "Chalchihuitán", Abreviation = "Chalchihuitán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07023", Name = "Chamula", Abreviation = "Chamula", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07024", Name = "Chanal", Abreviation = "Chanal", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07025", Name = "Chapultenango", Abreviation = "Chapultenango", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07026", Name = "Chenalhó", Abreviation = "Chenalhó", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07027", Name = "Chiapa de Corzo", Abreviation = "Chiapa de Corzo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07028", Name = "Chiapilla", Abreviation = "Chiapilla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07029", Name = "Chicoasén", Abreviation = "Chicoasén", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07030", Name = "Chicomuselo", Abreviation = "Chicomuselo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07031", Name = "Chilón", Abreviation = "Chilón", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07032", Name = "Escuintla", Abreviation = "Escuintla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07033", Name = "Francisco León", Abreviation = "Francisco León", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07034", Name = "Frontera Comalapa", Abreviation = "Frontera Comalapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07035", Name = "Frontera Hidalgo", Abreviation = "Frontera Hidalgo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07036", Name = "La Grandeza", Abreviation = "La Grandeza", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07037", Name = "Huehuetán", Abreviation = "Huehuetán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07038", Name = "Huixtán", Abreviation = "Huixtán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07039", Name = "Huitiupán", Abreviation = "Huitiupán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07040", Name = "Huixtla", Abreviation = "Huixtla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07041", Name = "La Independencia", Abreviation = "La Independencia", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07042", Name = "Ixhuatán", Abreviation = "Ixhuatán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07043", Name = "Ixtacomitán", Abreviation = "Ixtacomitán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07044", Name = "Ixtapa", Abreviation = "Ixtapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07045", Name = "Ixtapangajoya", Abreviation = "Ixtapangajoya", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07046", Name = "Jiquipilas", Abreviation = "Jiquipilas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07047", Name = "Jitotol", Abreviation = "Jitotol", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07048", Name = "Juárez", Abreviation = "Juárez", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07049", Name = "Larráinzar", Abreviation = "Larráinzar", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07050", Name = "La Libertad", Abreviation = "La Libertad", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07051", Name = "Mapastepec", Abreviation = "Mapastepec", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07052", Name = "Las Margaritas", Abreviation = "Las Margaritas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07053", Name = "Mazapa de Madero", Abreviation = "Mazapa de Madero", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07054", Name = "Mazatán", Abreviation = "Mazatán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07055", Name = "Metapa", Abreviation = "Metapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07056", Name = "Mitontic", Abreviation = "Mitontic", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07057", Name = "Motozintla", Abreviation = "Motozintla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07058", Name = "Nicolás Ruíz", Abreviation = "Nicolás Ruíz", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07059", Name = "Ocosingo", Abreviation = "Ocosingo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07060", Name = "Ocotepec", Abreviation = "Ocotepec", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07061", Name = "Ocozocoautla de Espinosa", Abreviation = "Ocozocoautla de Espinosa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07062", Name = "Ostuacán", Abreviation = "Ostuacán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07063", Name = "Osumacinta", Abreviation = "Osumacinta", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07064", Name = "Oxchuc", Abreviation = "Oxchuc", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07065", Name = "Palenque", Abreviation = "Palenque", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07066", Name = "Pantelhó", Abreviation = "Pantelhó", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07067", Name = "Pantepec", Abreviation = "Pantepec", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07068", Name = "Pichucalco", Abreviation = "Pichucalco", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07069", Name = "Pijijiapan", Abreviation = "Pijijiapan", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07070", Name = "El Porvenir", Abreviation = "El Porvenir", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07071", Name = "Villa Comaltitlán", Abreviation = "Villa Comaltitlán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07072", Name = "Pueblo Nuevo Solistahuacán", Abreviation = "Pueblo Nuevo Solistahuacán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07073", Name = "Rayón", Abreviation = "Rayón", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07074", Name = "Reforma", Abreviation = "Reforma", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07075", Name = "Las Rosas", Abreviation = "Las Rosas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07076", Name = "Sabanilla", Abreviation = "Sabanilla", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07077", Name = "Salto de Agua", Abreviation = "Salto de Agua", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07078", Name = "San Cristóbal de las Casas", Abreviation = "San Cristóbal de las Casas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07079", Name = "San Fernando", Abreviation = "San Fernando", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07080", Name = "Siltepec", Abreviation = "Siltepec", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07081", Name = "Simojovel", Abreviation = "Simojovel", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07082", Name = "Sitalá", Abreviation = "Sitalá", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07083", Name = "Socoltenango", Abreviation = "Socoltenango", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07084", Name = "Solosuchiapa", Abreviation = "Solosuchiapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07085", Name = "Soyaló", Abreviation = "Soyaló", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07086", Name = "Suchiapa", Abreviation = "Suchiapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07087", Name = "Suchiate", Abreviation = "Suchiate", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07088", Name = "Sunuapa", Abreviation = "Sunuapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07089", Name = "Tapachula", Abreviation = "Tapachula", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07090", Name = "Tapalapa", Abreviation = "Tapalapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07091", Name = "Tapilula", Abreviation = "Tapilula", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07092", Name = "Tecpatán", Abreviation = "Tecpatán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07093", Name = "Tenejapa", Abreviation = "Tenejapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07094", Name = "Teopisca", Abreviation = "Teopisca", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07096", Name = "Tila", Abreviation = "Tila", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07097", Name = "Tonalá", Abreviation = "Tonalá", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07098", Name = "Totolapa", Abreviation = "Totolapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07099", Name = "La Trinitaria", Abreviation = "La Trinitaria", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07100", Name = "Tumbalá", Abreviation = "Tumbalá", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07101", Name = "Tuxtla Gutiérrez", Abreviation = "Tuxtla Gutiérrez", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07102", Name = "Tuxtla Chico", Abreviation = "Tuxtla Chico", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07103", Name = "Tuzantán", Abreviation = "Tuzantán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07104", Name = "Tzimol", Abreviation = "Tzimol", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07105", Name = "Unión Juárez", Abreviation = "Unión Juárez", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07106", Name = "Venustiano Carranza", Abreviation = "Venustiano Carranza", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07107", Name = "Villa Corzo", Abreviation = "Villa Corzo", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07108", Name = "Villaflores", Abreviation = "Villaflores", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07109", Name = "Yajalón", Abreviation = "Yajalón", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07110", Name = "San Lucas", Abreviation = "San Lucas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07111", Name = "Zinacantán", Abreviation = "Zinacantán", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07112", Name = "San Juan Cancuc", Abreviation = "San Juan Cancuc", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07113", Name = "Aldama", Abreviation = "Aldama", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07114", Name = "Benemérito de las Américas", Abreviation = "Benemérito de las Américas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07115", Name = "Maravilla Tenejapa", Abreviation = "Maravilla Tenejapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07116", Name = "Marqués de Comillas", Abreviation = "Marqués de Comillas", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07117", Name = "Montecristo de Guerrero", Abreviation = "Montecristo de Guerrero", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07118", Name = "San Andrés Duraznal", Abreviation = "San Andrés Duraznal", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07119", Name = "Santiago el Pinar", Abreviation = "Santiago el Pinar", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07120", Name = "Capitán Luis Ángel Vidal", Abreviation = "Capitán Luis Ángel Vidal", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07121", Name = "Rincón Chamula San Pedro", Abreviation = "Rincón Chamula San Pedro", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07122", Name = "El Parral", Abreviation = "El Parral", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07123", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "07124", Name = "Mezcalapa", Abreviation = "Mezcalapa", IsActive = true, StateId = "07" },
                    new Domain.City() { Id = "08001", Name = "Ahumada", Abreviation = "Ahumada", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08002", Name = "Aldama", Abreviation = "Aldama", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08003", Name = "Allende", Abreviation = "Allende", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08004", Name = "Aquiles Serdán", Abreviation = "Aquiles Serdán", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08005", Name = "Ascensión", Abreviation = "Ascensión", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08006", Name = "Bachíniva", Abreviation = "Bachíniva", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08007", Name = "Balleza", Abreviation = "Balleza", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08008", Name = "Batopilas de Manuel Gómez Morín", Abreviation = "Batopilas de Manuel Gómez Morín", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08009", Name = "Bocoyna", Abreviation = "Bocoyna", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08010", Name = "Buenaventura", Abreviation = "Buenaventura", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08011", Name = "Camargo", Abreviation = "Camargo", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08012", Name = "Carichí", Abreviation = "Carichí", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08013", Name = "Casas Grandes", Abreviation = "Casas Grandes", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08014", Name = "Coronado", Abreviation = "Coronado", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08015", Name = "Coyame del Sotol", Abreviation = "Coyame del Sotol", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08016", Name = "La Cruz", Abreviation = "La Cruz", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08017", Name = "Cuauhtémoc", Abreviation = "Cuauhtémoc", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08018", Name = "Cusihuiriachi", Abreviation = "Cusihuiriachi", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08019", Name = "Chihuahua", Abreviation = "Chihuahua", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08020", Name = "Chínipas", Abreviation = "Chínipas", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08021", Name = "Delicias", Abreviation = "Delicias", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08022", Name = "Dr. Belisario Domínguez", Abreviation = "Dr. Belisario Domínguez", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08023", Name = "Galeana", Abreviation = "Galeana", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08024", Name = "Santa Isabel", Abreviation = "Santa Isabel", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08025", Name = "Gómez Farías", Abreviation = "Gómez Farías", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08026", Name = "Gran Morelos", Abreviation = "Gran Morelos", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08027", Name = "Guachochi", Abreviation = "Guachochi", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08028", Name = "Guadalupe", Abreviation = "Guadalupe", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08029", Name = "Guadalupe y Calvo", Abreviation = "Guadalupe y Calvo", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08030", Name = "Guazapares", Abreviation = "Guazapares", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08031", Name = "Guerrero", Abreviation = "Guerrero", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08032", Name = "Hidalgo del Parral", Abreviation = "Hidalgo del Parral", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08033", Name = "Huejotitán", Abreviation = "Huejotitán", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08034", Name = "Ignacio Zaragoza", Abreviation = "Ignacio Zaragoza", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08035", Name = "Janos", Abreviation = "Janos", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08036", Name = "Jiménez", Abreviation = "Jiménez", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08037", Name = "Juárez", Abreviation = "Juárez", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08038", Name = "Julimes", Abreviation = "Julimes", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08039", Name = "López", Abreviation = "López", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08040", Name = "Madera", Abreviation = "Madera", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08041", Name = "Maguarichi", Abreviation = "Maguarichi", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08042", Name = "Manuel Benavides", Abreviation = "Manuel Benavides", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08043", Name = "Matachí", Abreviation = "Matachí", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08044", Name = "Matamoros", Abreviation = "Matamoros", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08045", Name = "Meoqui", Abreviation = "Meoqui", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08046", Name = "Morelos", Abreviation = "Morelos", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08047", Name = "Moris", Abreviation = "Moris", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08048", Name = "Namiquipa", Abreviation = "Namiquipa", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08049", Name = "Nonoava", Abreviation = "Nonoava", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08050", Name = "Nuevo Casas Grandes", Abreviation = "Nuevo Casas Grandes", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08051", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08052", Name = "Ojinaga", Abreviation = "Ojinaga", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08053", Name = "Praxedis G. Guerrero", Abreviation = "Praxedis G. Guerrero", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08054", Name = "Riva Palacio", Abreviation = "Riva Palacio", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08055", Name = "Rosales", Abreviation = "Rosales", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08056", Name = "Rosario", Abreviation = "Rosario", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08057", Name = "San Francisco de Borja", Abreviation = "San Francisco de Borja", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08058", Name = "San Francisco de Conchos", Abreviation = "San Francisco de Conchos", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08059", Name = "San Francisco del Oro", Abreviation = "San Francisco del Oro", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08060", Name = "Santa Bárbara", Abreviation = "Santa Bárbara", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08061", Name = "Satevó", Abreviation = "Satevó", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08062", Name = "Saucillo", Abreviation = "Saucillo", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08063", Name = "Temósachic", Abreviation = "Temósachic", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08064", Name = "El Tule", Abreviation = "El Tule", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08065", Name = "Urique", Abreviation = "Urique", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08066", Name = "Uruachi", Abreviation = "Uruachi", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "08067", Name = "Valle de Zaragoza", Abreviation = "Valle de Zaragoza", IsActive = true, StateId = "08" },
                    new Domain.City() { Id = "09002", Name = "Azcapotzalco", Abreviation = "Azcapotzalco", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09003", Name = "Coyoacán", Abreviation = "Coyoacán", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09004", Name = "Cuajimalpa de Morelos", Abreviation = "Cuajimalpa de Morelos", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09005", Name = "Gustavo A. Madero", Abreviation = "Gustavo A. Madero", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09006", Name = "Iztacalco", Abreviation = "Iztacalco", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09007", Name = "Iztapalapa", Abreviation = "Iztapalapa", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09008", Name = "La Magdalena Contreras", Abreviation = "La Magdalena Contreras", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09009", Name = "Milpa Alta", Abreviation = "Milpa Alta", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09010", Name = "Álvaro Obregón", Abreviation = "Álvaro Obregón", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09011", Name = "Tláhuac", Abreviation = "Tláhuac", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09012", Name = "Tlalpan", Abreviation = "Tlalpan", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09013", Name = "Xochimilco", Abreviation = "Xochimilco", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09014", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09015", Name = "Cuauhtémoc", Abreviation = "Cuauhtémoc", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09016", Name = "Miguel Hidalgo", Abreviation = "Miguel Hidalgo", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "09017", Name = "Venustiano Carranza", Abreviation = "Venustiano Carranza", IsActive = true, StateId = "09" },
                    new Domain.City() { Id = "10001", Name = "Canatlán", Abreviation = "Canatlán", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10002", Name = "Canelas", Abreviation = "Canelas", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10003", Name = "Coneto de Comonfort", Abreviation = "Coneto de Comonfort", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10004", Name = "Cuencamé", Abreviation = "Cuencamé", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10005", Name = "Durango", Abreviation = "Durango", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10006", Name = "General Simón Bolívar", Abreviation = "General Simón Bolívar", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10007", Name = "Gómez Palacio", Abreviation = "Gómez Palacio", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10008", Name = "Guadalupe Victoria", Abreviation = "Guadalupe Victoria", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10009", Name = "Guanaceví", Abreviation = "Guanaceví", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10010", Name = "Hidalgo", Abreviation = "Hidalgo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10011", Name = "Indé", Abreviation = "Indé", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10012", Name = "Lerdo", Abreviation = "Lerdo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10013", Name = "Mapimí", Abreviation = "Mapimí", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10014", Name = "Mezquital", Abreviation = "Mezquital", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10015", Name = "Nazas", Abreviation = "Nazas", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10016", Name = "Nombre de Dios", Abreviation = "Nombre de Dios", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10017", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10018", Name = "El Oro", Abreviation = "El Oro", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10019", Name = "Otáez", Abreviation = "Otáez", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10020", Name = "Pánuco de Coronado", Abreviation = "Pánuco de Coronado", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10021", Name = "Peñón Blanco", Abreviation = "Peñón Blanco", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10022", Name = "Poanas", Abreviation = "Poanas", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10023", Name = "Pueblo Nuevo", Abreviation = "Pueblo Nuevo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10024", Name = "Rodeo", Abreviation = "Rodeo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10025", Name = "San Bernardo", Abreviation = "San Bernardo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10026", Name = "San Dimas", Abreviation = "San Dimas", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10027", Name = "San Juan de Guadalupe", Abreviation = "San Juan de Guadalupe", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10028", Name = "San Juan del Río", Abreviation = "San Juan del Río", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10029", Name = "San Luis del Cordero", Abreviation = "San Luis del Cordero", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10030", Name = "San Pedro del Gallo", Abreviation = "San Pedro del Gallo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10031", Name = "Santa Clara", Abreviation = "Santa Clara", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10032", Name = "Santiago Papasquiaro", Abreviation = "Santiago Papasquiaro", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10033", Name = "Súchil", Abreviation = "Súchil", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10034", Name = "Tamazula", Abreviation = "Tamazula", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10035", Name = "Tepehuanes", Abreviation = "Tepehuanes", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10036", Name = "Tlahualilo", Abreviation = "Tlahualilo", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10037", Name = "Topia", Abreviation = "Topia", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10038", Name = "Vicente Guerrero", Abreviation = "Vicente Guerrero", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "10039", Name = "Nuevo Ideal", Abreviation = "Nuevo Ideal", IsActive = true, StateId = "10" },
                    new Domain.City() { Id = "11001", Name = "Abasolo", Abreviation = "Abasolo", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11002", Name = "Acámbaro", Abreviation = "Acámbaro", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11003", Name = "San Miguel de Allende", Abreviation = "San Miguel de Allende", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11004", Name = "Apaseo el Alto", Abreviation = "Apaseo el Alto", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11005", Name = "Apaseo el Grande", Abreviation = "Apaseo el Grande", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11006", Name = "Atarjea", Abreviation = "Atarjea", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11007", Name = "Celaya", Abreviation = "Celaya", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11008", Name = "Manuel Doblado", Abreviation = "Manuel Doblado", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11009", Name = "Comonfort", Abreviation = "Comonfort", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11010", Name = "Coroneo", Abreviation = "Coroneo", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11011", Name = "Cortazar", Abreviation = "Cortazar", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11012", Name = "Cuerámaro", Abreviation = "Cuerámaro", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11013", Name = "Doctor Mora", Abreviation = "Doctor Mora", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11014", Name = "Dolores Hidalgo Cuna de la Independencia Nacional", Abreviation = "Dolores Hidalgo Cuna de la Independencia Nacional", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11015", Name = "Guanajuato", Abreviation = "Guanajuato", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11016", Name = "Huanímaro", Abreviation = "Huanímaro", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11017", Name = "Irapuato", Abreviation = "Irapuato", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11018", Name = "Jaral del Progreso", Abreviation = "Jaral del Progreso", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11019", Name = "Jerécuaro", Abreviation = "Jerécuaro", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11020", Name = "León", Abreviation = "León", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11021", Name = "Moroleón", Abreviation = "Moroleón", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11022", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11023", Name = "Pénjamo", Abreviation = "Pénjamo", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11024", Name = "Pueblo Nuevo", Abreviation = "Pueblo Nuevo", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11025", Name = "Purísima del Rincón", Abreviation = "Purísima del Rincón", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11026", Name = "Romita", Abreviation = "Romita", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11027", Name = "Salamanca", Abreviation = "Salamanca", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11028", Name = "Salvatierra", Abreviation = "Salvatierra", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11029", Name = "San Diego de la Unión", Abreviation = "San Diego de la Unión", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11030", Name = "San Felipe", Abreviation = "San Felipe", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11031", Name = "San Francisco del Rincón", Abreviation = "San Francisco del Rincón", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11032", Name = "San José Iturbide", Abreviation = "San José Iturbide", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11033", Name = "San Luis de la Paz", Abreviation = "San Luis de la Paz", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11034", Name = "Santa Catarina", Abreviation = "Santa Catarina", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11035", Name = "Santa Cruz de Juventino Rosas", Abreviation = "Santa Cruz de Juventino Rosas", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11036", Name = "Santiago Maravatío", Abreviation = "Santiago Maravatío", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11037", Name = "Silao de la Victoria", Abreviation = "Silao de la Victoria", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11038", Name = "Tarandacuao", Abreviation = "Tarandacuao", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11039", Name = "Tarimoro", Abreviation = "Tarimoro", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11040", Name = "Tierra Blanca", Abreviation = "Tierra Blanca", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11041", Name = "Uriangato", Abreviation = "Uriangato", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11042", Name = "Valle de Santiago", Abreviation = "Valle de Santiago", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11043", Name = "Victoria", Abreviation = "Victoria", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11044", Name = "Villagrán", Abreviation = "Villagrán", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11045", Name = "Xichú", Abreviation = "Xichú", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "11046", Name = "Yuriria", Abreviation = "Yuriria", IsActive = true, StateId = "11" },
                    new Domain.City() { Id = "12001", Name = "Acapulco de Juárez", Abreviation = "Acapulco de Juárez", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12002", Name = "Ahuacuotzingo", Abreviation = "Ahuacuotzingo", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12003", Name = "Ajuchitlán del Progreso", Abreviation = "Ajuchitlán del Progreso", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12004", Name = "Alcozauca de Guerrero", Abreviation = "Alcozauca de Guerrero", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12005", Name = "Alpoyeca", Abreviation = "Alpoyeca", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12006", Name = "Apaxtla", Abreviation = "Apaxtla", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12007", Name = "Arcelia", Abreviation = "Arcelia", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12008", Name = "Atenango del Río", Abreviation = "Atenango del Río", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12009", Name = "Atlamajalcingo del Monte", Abreviation = "Atlamajalcingo del Monte", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12010", Name = "Atlixtac", Abreviation = "Atlixtac", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12011", Name = "Atoyac de Álvarez", Abreviation = "Atoyac de Álvarez", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12012", Name = "Ayutla de los Libres", Abreviation = "Ayutla de los Libres", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12013", Name = "Azoyú", Abreviation = "Azoyú", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12014", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12015", Name = "Buenavista de Cuéllar", Abreviation = "Buenavista de Cuéllar", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12016", Name = "Coahuayutla de José María Izazaga", Abreviation = "Coahuayutla de José María Izazaga", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12017", Name = "Cocula", Abreviation = "Cocula", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12018", Name = "Copala", Abreviation = "Copala", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12019", Name = "Copalillo", Abreviation = "Copalillo", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12020", Name = "Copanatoyac", Abreviation = "Copanatoyac", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12021", Name = "Coyuca de Benítez", Abreviation = "Coyuca de Benítez", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12022", Name = "Coyuca de Catalán", Abreviation = "Coyuca de Catalán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12023", Name = "Cuajinicuilapa", Abreviation = "Cuajinicuilapa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12024", Name = "Cualác", Abreviation = "Cualác", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12025", Name = "Cuautepec", Abreviation = "Cuautepec", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12026", Name = "Cuetzala del Progreso", Abreviation = "Cuetzala del Progreso", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12027", Name = "Cutzamala de Pinzón", Abreviation = "Cutzamala de Pinzón", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12028", Name = "Chilapa de Álvarez", Abreviation = "Chilapa de Álvarez", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12029", Name = "Chilpancingo de los Bravo", Abreviation = "Chilpancingo de los Bravo", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12030", Name = "Florencio Villarreal", Abreviation = "Florencio Villarreal", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12031", Name = "General Canuto A. Neri", Abreviation = "General Canuto A. Neri", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12032", Name = "General Heliodoro Castillo", Abreviation = "General Heliodoro Castillo", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12033", Name = "Huamuxtitlán", Abreviation = "Huamuxtitlán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12034", Name = "Huitzuco de los Figueroa", Abreviation = "Huitzuco de los Figueroa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12035", Name = "Iguala de la Independencia", Abreviation = "Iguala de la Independencia", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12036", Name = "Igualapa", Abreviation = "Igualapa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12037", Name = "Ixcateopan de Cuauhtémoc", Abreviation = "Ixcateopan de Cuauhtémoc", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12038", Name = "Zihuatanejo de Azueta", Abreviation = "Zihuatanejo de Azueta", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12039", Name = "Juan R. Escudero", Abreviation = "Juan R. Escudero", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12040", Name = "Leonardo Bravo", Abreviation = "Leonardo Bravo", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12041", Name = "Malinaltepec", Abreviation = "Malinaltepec", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12042", Name = "Mártir de Cuilapan", Abreviation = "Mártir de Cuilapan", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12043", Name = "Metlatónoc", Abreviation = "Metlatónoc", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12044", Name = "Mochitlán", Abreviation = "Mochitlán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12045", Name = "Olinalá", Abreviation = "Olinalá", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12046", Name = "Ometepec", Abreviation = "Ometepec", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12047", Name = "Pedro Ascencio Alquisiras", Abreviation = "Pedro Ascencio Alquisiras", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12048", Name = "Petatlán", Abreviation = "Petatlán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12049", Name = "Pilcaya", Abreviation = "Pilcaya", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12050", Name = "Pungarabato", Abreviation = "Pungarabato", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12051", Name = "Quechultenango", Abreviation = "Quechultenango", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12052", Name = "San Luis Acatlán", Abreviation = "San Luis Acatlán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12053", Name = "San Marcos", Abreviation = "San Marcos", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12054", Name = "San Miguel Totolapan", Abreviation = "San Miguel Totolapan", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12055", Name = "Taxco de Alarcón", Abreviation = "Taxco de Alarcón", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12056", Name = "Tecoanapa", Abreviation = "Tecoanapa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12057", Name = "Técpan de Galeana", Abreviation = "Técpan de Galeana", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12058", Name = "Teloloapan", Abreviation = "Teloloapan", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12059", Name = "Tepecoacuilco de Trujano", Abreviation = "Tepecoacuilco de Trujano", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12060", Name = "Tetipac", Abreviation = "Tetipac", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12061", Name = "Tixtla de Guerrero", Abreviation = "Tixtla de Guerrero", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12062", Name = "Tlacoachistlahuaca", Abreviation = "Tlacoachistlahuaca", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12063", Name = "Tlacoapa", Abreviation = "Tlacoapa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12064", Name = "Tlalchapa", Abreviation = "Tlalchapa", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12065", Name = "Tlalixtaquilla de Maldonado", Abreviation = "Tlalixtaquilla de Maldonado", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12066", Name = "Tlapa de Comonfort", Abreviation = "Tlapa de Comonfort", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12067", Name = "Tlapehuala", Abreviation = "Tlapehuala", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12068", Name = "La Unión de Isidoro Montes de Oca", Abreviation = "La Unión de Isidoro Montes de Oca", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12069", Name = "Xalpatláhuac", Abreviation = "Xalpatláhuac", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12070", Name = "Xochihuehuetlán", Abreviation = "Xochihuehuetlán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12071", Name = "Xochistlahuaca", Abreviation = "Xochistlahuaca", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12072", Name = "Zapotitlán Tablas", Abreviation = "Zapotitlán Tablas", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12073", Name = "Zirándaro", Abreviation = "Zirándaro", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12074", Name = "Zitlala", Abreviation = "Zitlala", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12075", Name = "Eduardo Neri", Abreviation = "Eduardo Neri", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12076", Name = "Acatepec", Abreviation = "Acatepec", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12077", Name = "Marquelia", Abreviation = "Marquelia", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12078", Name = "Cochoapa el Grande", Abreviation = "Cochoapa el Grande", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12079", Name = "José Joaquín de Herrera", Abreviation = "José Joaquín de Herrera", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12080", Name = "Juchitán", Abreviation = "Juchitán", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "12081", Name = "Iliatenco", Abreviation = "Iliatenco", IsActive = true, StateId = "12" },
                    new Domain.City() { Id = "13001", Name = "Acatlán", Abreviation = "Acatlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13002", Name = "Acaxochitlán", Abreviation = "Acaxochitlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13003", Name = "Actopan", Abreviation = "Actopan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13004", Name = "Agua Blanca de Iturbide", Abreviation = "Agua Blanca de Iturbide", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13005", Name = "Ajacuba", Abreviation = "Ajacuba", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13006", Name = "Alfajayucan", Abreviation = "Alfajayucan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13007", Name = "Almoloya", Abreviation = "Almoloya", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13008", Name = "Apan", Abreviation = "Apan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13009", Name = "El Arenal", Abreviation = "El Arenal", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13010", Name = "Atitalaquia", Abreviation = "Atitalaquia", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13011", Name = "Atlapexco", Abreviation = "Atlapexco", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13012", Name = "Atotonilco el Grande", Abreviation = "Atotonilco el Grande", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13013", Name = "Atotonilco de Tula", Abreviation = "Atotonilco de Tula", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13014", Name = "Calnali", Abreviation = "Calnali", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13015", Name = "Cardonal", Abreviation = "Cardonal", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13016", Name = "Cuautepec de Hinojosa", Abreviation = "Cuautepec de Hinojosa", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13017", Name = "Chapantongo", Abreviation = "Chapantongo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13018", Name = "Chapulhuacán", Abreviation = "Chapulhuacán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13019", Name = "Chilcuautla", Abreviation = "Chilcuautla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13020", Name = "Eloxochitlán", Abreviation = "Eloxochitlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13021", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13022", Name = "Epazoyucan", Abreviation = "Epazoyucan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13023", Name = "Francisco I. Madero", Abreviation = "Francisco I. Madero", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13024", Name = "Huasca de Ocampo", Abreviation = "Huasca de Ocampo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13025", Name = "Huautla", Abreviation = "Huautla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13026", Name = "Huazalingo", Abreviation = "Huazalingo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13027", Name = "Huehuetla", Abreviation = "Huehuetla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13028", Name = "Huejutla de Reyes", Abreviation = "Huejutla de Reyes", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13029", Name = "Huichapan", Abreviation = "Huichapan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13030", Name = "Ixmiquilpan", Abreviation = "Ixmiquilpan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13031", Name = "Jacala de Ledezma", Abreviation = "Jacala de Ledezma", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13032", Name = "Jaltocán", Abreviation = "Jaltocán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13033", Name = "Juárez Hidalgo", Abreviation = "Juárez Hidalgo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13034", Name = "Lolotla", Abreviation = "Lolotla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13035", Name = "Metepec", Abreviation = "Metepec", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13036", Name = "San Agustín Metzquititlán", Abreviation = "San Agustín Metzquititlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13037", Name = "Metztitlán", Abreviation = "Metztitlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13038", Name = "Mineral del Chico", Abreviation = "Mineral del Chico", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13039", Name = "Mineral del Monte", Abreviation = "Mineral del Monte", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13040", Name = "La Misión", Abreviation = "La Misión", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13041", Name = "Mixquiahuala de Juárez", Abreviation = "Mixquiahuala de Juárez", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13042", Name = "Molango de Escamilla", Abreviation = "Molango de Escamilla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13043", Name = "Nicolás Flores", Abreviation = "Nicolás Flores", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13044", Name = "Nopala de Villagrán", Abreviation = "Nopala de Villagrán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13045", Name = "Omitlán de Juárez", Abreviation = "Omitlán de Juárez", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13046", Name = "San Felipe Orizatlán", Abreviation = "San Felipe Orizatlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13047", Name = "Pacula", Abreviation = "Pacula", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13048", Name = "Pachuca de Soto", Abreviation = "Pachuca de Soto", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13049", Name = "Pisaflores", Abreviation = "Pisaflores", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13050", Name = "Progreso de Obregón", Abreviation = "Progreso de Obregón", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13051", Name = "Mineral de la Reforma", Abreviation = "Mineral de la Reforma", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13052", Name = "San Agustín Tlaxiaca", Abreviation = "San Agustín Tlaxiaca", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13053", Name = "San Bartolo Tutotepec", Abreviation = "San Bartolo Tutotepec", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13054", Name = "San Salvador", Abreviation = "San Salvador", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13055", Name = "Santiago de Anaya", Abreviation = "Santiago de Anaya", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13056", Name = "Santiago Tulantepec de Lugo Guerrero", Abreviation = "Santiago Tulantepec de Lugo Guerrero", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13057", Name = "Singuilucan", Abreviation = "Singuilucan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13058", Name = "Tasquillo", Abreviation = "Tasquillo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13059", Name = "Tecozautla", Abreviation = "Tecozautla", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13060", Name = "Tenango de Doria", Abreviation = "Tenango de Doria", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13061", Name = "Tepeapulco", Abreviation = "Tepeapulco", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13062", Name = "Tepehuacán de Guerrero", Abreviation = "Tepehuacán de Guerrero", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13063", Name = "Tepeji del Río de Ocampo", Abreviation = "Tepeji del Río de Ocampo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13064", Name = "Tepetitlán", Abreviation = "Tepetitlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13065", Name = "Tetepango", Abreviation = "Tetepango", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13066", Name = "Villa de Tezontepec", Abreviation = "Villa de Tezontepec", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13067", Name = "Tezontepec de Aldama", Abreviation = "Tezontepec de Aldama", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13068", Name = "Tianguistengo", Abreviation = "Tianguistengo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13069", Name = "Tizayuca", Abreviation = "Tizayuca", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13070", Name = "Tlahuelilpan", Abreviation = "Tlahuelilpan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13071", Name = "Tlahuiltepa", Abreviation = "Tlahuiltepa", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13072", Name = "Tlanalapa", Abreviation = "Tlanalapa", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13073", Name = "Tlanchinol", Abreviation = "Tlanchinol", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13074", Name = "Tlaxcoapan", Abreviation = "Tlaxcoapan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13075", Name = "Tolcayuca", Abreviation = "Tolcayuca", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13076", Name = "Tula de Allende", Abreviation = "Tula de Allende", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13077", Name = "Tulancingo de Bravo", Abreviation = "Tulancingo de Bravo", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13078", Name = "Xochiatipan", Abreviation = "Xochiatipan", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13079", Name = "Xochicoatlán", Abreviation = "Xochicoatlán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13080", Name = "Yahualica", Abreviation = "Yahualica", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13081", Name = "Zacualtipán de Ángeles", Abreviation = "Zacualtipán de Ángeles", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13082", Name = "Zapotlán de Juárez", Abreviation = "Zapotlán de Juárez", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13083", Name = "Zempoala", Abreviation = "Zempoala", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "13084", Name = "Zimapán", Abreviation = "Zimapán", IsActive = true, StateId = "13" },
                    new Domain.City() { Id = "14001", Name = "Acatic", Abreviation = "Acatic", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14002", Name = "Acatlán de Juárez", Abreviation = "Acatlán de Juárez", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14003", Name = "Ahualulco de Mercado", Abreviation = "Ahualulco de Mercado", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14004", Name = "Amacueca", Abreviation = "Amacueca", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14005", Name = "Amatitán", Abreviation = "Amatitán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14006", Name = "Ameca", Abreviation = "Ameca", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14007", Name = "San Juanito de Escobedo", Abreviation = "San Juanito de Escobedo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14008", Name = "Arandas", Abreviation = "Arandas", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14009", Name = "El Arenal", Abreviation = "El Arenal", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14010", Name = "Atemajac de Brizuela", Abreviation = "Atemajac de Brizuela", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14011", Name = "Atengo", Abreviation = "Atengo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14012", Name = "Atenguillo", Abreviation = "Atenguillo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14013", Name = "Atotonilco el Alto", Abreviation = "Atotonilco el Alto", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14014", Name = "Atoyac", Abreviation = "Atoyac", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14015", Name = "Autlán de Navarro", Abreviation = "Autlán de Navarro", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14016", Name = "Ayotlán", Abreviation = "Ayotlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14017", Name = "Ayutla", Abreviation = "Ayutla", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14018", Name = "La Barca", Abreviation = "La Barca", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14019", Name = "Bolaños", Abreviation = "Bolaños", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14020", Name = "Cabo Corrientes", Abreviation = "Cabo Corrientes", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14021", Name = "Casimiro Castillo", Abreviation = "Casimiro Castillo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14022", Name = "Cihuatlán", Abreviation = "Cihuatlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14023", Name = "Zapotlán el Grande", Abreviation = "Zapotlán el Grande", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14024", Name = "Cocula", Abreviation = "Cocula", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14025", Name = "Colotlán", Abreviation = "Colotlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14026", Name = "Concepción de Buenos Aires", Abreviation = "Concepción de Buenos Aires", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14027", Name = "Cuautitlán de García Barragán", Abreviation = "Cuautitlán de García Barragán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14028", Name = "Cuautla", Abreviation = "Cuautla", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14029", Name = "Cuquío", Abreviation = "Cuquío", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14030", Name = "Chapala", Abreviation = "Chapala", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14031", Name = "Chimaltitán", Abreviation = "Chimaltitán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14032", Name = "Chiquilistlán", Abreviation = "Chiquilistlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14033", Name = "Degollado", Abreviation = "Degollado", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14034", Name = "Ejutla", Abreviation = "Ejutla", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14035", Name = "Encarnación de Díaz", Abreviation = "Encarnación de Díaz", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14036", Name = "Etzatlán", Abreviation = "Etzatlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14037", Name = "El Grullo", Abreviation = "El Grullo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14038", Name = "Guachinango", Abreviation = "Guachinango", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14039", Name = "Guadalajara", Abreviation = "Guadalajara", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14040", Name = "Hostotipaquillo", Abreviation = "Hostotipaquillo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14041", Name = "Huejúcar", Abreviation = "Huejúcar", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14042", Name = "Huejuquilla el Alto", Abreviation = "Huejuquilla el Alto", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14043", Name = "La Huerta", Abreviation = "La Huerta", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14044", Name = "Ixtlahuacán de los Membrillos", Abreviation = "Ixtlahuacán de los Membrillos", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14045", Name = "Ixtlahuacán del Río", Abreviation = "Ixtlahuacán del Río", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14046", Name = "Jalostotitlán", Abreviation = "Jalostotitlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14047", Name = "Jamay", Abreviation = "Jamay", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14048", Name = "Jesús María", Abreviation = "Jesús María", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14049", Name = "Jilotlán de los Dolores", Abreviation = "Jilotlán de los Dolores", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14050", Name = "Jocotepec", Abreviation = "Jocotepec", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14051", Name = "Juanacatlán", Abreviation = "Juanacatlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14052", Name = "Juchitlán", Abreviation = "Juchitlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14053", Name = "Lagos de Moreno", Abreviation = "Lagos de Moreno", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14054", Name = "El Limón", Abreviation = "El Limón", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14055", Name = "Magdalena", Abreviation = "Magdalena", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14056", Name = "Santa María del Oro", Abreviation = "Santa María del Oro", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14057", Name = "La Manzanilla de la Paz", Abreviation = "La Manzanilla de la Paz", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14058", Name = "Mascota", Abreviation = "Mascota", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14059", Name = "Mazamitla", Abreviation = "Mazamitla", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14060", Name = "Mexticacán", Abreviation = "Mexticacán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14061", Name = "Mezquitic", Abreviation = "Mezquitic", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14062", Name = "Mixtlán", Abreviation = "Mixtlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14063", Name = "Ocotlán", Abreviation = "Ocotlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14064", Name = "Ojuelos de Jalisco", Abreviation = "Ojuelos de Jalisco", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14065", Name = "Pihuamo", Abreviation = "Pihuamo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14066", Name = "Poncitlán", Abreviation = "Poncitlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14067", Name = "Puerto Vallarta", Abreviation = "Puerto Vallarta", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14068", Name = "Villa Purificación", Abreviation = "Villa Purificación", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14069", Name = "Quitupan", Abreviation = "Quitupan", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14070", Name = "El Salto", Abreviation = "El Salto", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14071", Name = "San Cristóbal de la Barranca", Abreviation = "San Cristóbal de la Barranca", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14072", Name = "San Diego de Alejandría", Abreviation = "San Diego de Alejandría", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14073", Name = "San Juan de los Lagos", Abreviation = "San Juan de los Lagos", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14074", Name = "San Julián", Abreviation = "San Julián", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14075", Name = "San Marcos", Abreviation = "San Marcos", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14076", Name = "San Martín de Bolaños", Abreviation = "San Martín de Bolaños", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14077", Name = "San Martín Hidalgo", Abreviation = "San Martín Hidalgo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14078", Name = "San Miguel el Alto", Abreviation = "San Miguel el Alto", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14079", Name = "Gómez Farías", Abreviation = "Gómez Farías", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14080", Name = "San Sebastián del Oeste", Abreviation = "San Sebastián del Oeste", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14081", Name = "Santa María de los Ángeles", Abreviation = "Santa María de los Ángeles", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14082", Name = "Sayula", Abreviation = "Sayula", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14083", Name = "Tala", Abreviation = "Tala", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14084", Name = "Talpa de Allende", Abreviation = "Talpa de Allende", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14085", Name = "Tamazula de Gordiano", Abreviation = "Tamazula de Gordiano", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14086", Name = "Tapalpa", Abreviation = "Tapalpa", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14087", Name = "Tecalitlán", Abreviation = "Tecalitlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14088", Name = "Tecolotlán", Abreviation = "Tecolotlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14089", Name = "Techaluta de Montenegro", Abreviation = "Techaluta de Montenegro", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14090", Name = "Tenamaxtlán", Abreviation = "Tenamaxtlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14091", Name = "Teocaltiche", Abreviation = "Teocaltiche", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14092", Name = "Teocuitatlán de Corona", Abreviation = "Teocuitatlán de Corona", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14093", Name = "Tepatitlán de Morelos", Abreviation = "Tepatitlán de Morelos", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14094", Name = "Tequila", Abreviation = "Tequila", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14095", Name = "Teuchitlán", Abreviation = "Teuchitlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14096", Name = "Tizapán el Alto", Abreviation = "Tizapán el Alto", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14097", Name = "Tlajomulco de Zúñiga", Abreviation = "Tlajomulco de Zúñiga", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14098", Name = "San Pedro Tlaquepaque", Abreviation = "San Pedro Tlaquepaque", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14099", Name = "Tolimán", Abreviation = "Tolimán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14100", Name = "Tomatlán", Abreviation = "Tomatlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14101", Name = "Tonalá", Abreviation = "Tonalá", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14102", Name = "Tonaya", Abreviation = "Tonaya", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14103", Name = "Tonila", Abreviation = "Tonila", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14104", Name = "Totatiche", Abreviation = "Totatiche", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14105", Name = "Tototlán", Abreviation = "Tototlán", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14106", Name = "Tuxcacuesco", Abreviation = "Tuxcacuesco", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14107", Name = "Tuxcueca", Abreviation = "Tuxcueca", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14108", Name = "Tuxpan", Abreviation = "Tuxpan", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14109", Name = "Unión de San Antonio", Abreviation = "Unión de San Antonio", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14110", Name = "Unión de Tula", Abreviation = "Unión de Tula", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14111", Name = "Valle de Guadalupe", Abreviation = "Valle de Guadalupe", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14112", Name = "Valle de Juárez", Abreviation = "Valle de Juárez", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14113", Name = "San Gabriel", Abreviation = "San Gabriel", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14114", Name = "Villa Corona", Abreviation = "Villa Corona", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14115", Name = "Villa Guerrero", Abreviation = "Villa Guerrero", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14116", Name = "Villa Hidalgo", Abreviation = "Villa Hidalgo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14117", Name = "Cañadas de Obregón", Abreviation = "Cañadas de Obregón", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14118", Name = "Yahualica de González Gallo", Abreviation = "Yahualica de González Gallo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14119", Name = "Zacoalco de Torres", Abreviation = "Zacoalco de Torres", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14120", Name = "Zapopan", Abreviation = "Zapopan", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14121", Name = "Zapotiltic", Abreviation = "Zapotiltic", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14122", Name = "Zapotitlán de Vadillo", Abreviation = "Zapotitlán de Vadillo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14123", Name = "Zapotlán del Rey", Abreviation = "Zapotlán del Rey", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14124", Name = "Zapotlanejo", Abreviation = "Zapotlanejo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "14125", Name = "San Ignacio Cerro Gordo", Abreviation = "San Ignacio Cerro Gordo", IsActive = true, StateId = "14" },
                    new Domain.City() { Id = "15001", Name = "Acambay de Ruíz Castañeda", Abreviation = "Acambay de Ruíz Castañeda", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15002", Name = "Acolman", Abreviation = "Acolman", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15003", Name = "Aculco", Abreviation = "Aculco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15004", Name = "Almoloya de Alquisiras", Abreviation = "Almoloya de Alquisiras", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15005", Name = "Almoloya de Juárez", Abreviation = "Almoloya de Juárez", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15006", Name = "Almoloya del Río", Abreviation = "Almoloya del Río", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15007", Name = "Amanalco", Abreviation = "Amanalco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15008", Name = "Amatepec", Abreviation = "Amatepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15009", Name = "Amecameca", Abreviation = "Amecameca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15010", Name = "Apaxco", Abreviation = "Apaxco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15011", Name = "Atenco", Abreviation = "Atenco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15012", Name = "Atizapán", Abreviation = "Atizapán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15013", Name = "Atizapán de Zaragoza", Abreviation = "Atizapán de Zaragoza", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15014", Name = "Atlacomulco", Abreviation = "Atlacomulco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15015", Name = "Atlautla", Abreviation = "Atlautla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15016", Name = "Axapusco", Abreviation = "Axapusco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15017", Name = "Ayapango", Abreviation = "Ayapango", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15018", Name = "Calimaya", Abreviation = "Calimaya", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15019", Name = "Capulhuac", Abreviation = "Capulhuac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15020", Name = "Coacalco de Berriozábal", Abreviation = "Coacalco de Berriozábal", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15021", Name = "Coatepec Harinas", Abreviation = "Coatepec Harinas", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15022", Name = "Cocotitlán", Abreviation = "Cocotitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15023", Name = "Coyotepec", Abreviation = "Coyotepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15024", Name = "Cuautitlán", Abreviation = "Cuautitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15025", Name = "Chalco", Abreviation = "Chalco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15026", Name = "Chapa de Mota", Abreviation = "Chapa de Mota", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15027", Name = "Chapultepec", Abreviation = "Chapultepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15028", Name = "Chiautla", Abreviation = "Chiautla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15029", Name = "Chicoloapan", Abreviation = "Chicoloapan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15030", Name = "Chiconcuac", Abreviation = "Chiconcuac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15031", Name = "Chimalhuacán", Abreviation = "Chimalhuacán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15032", Name = "Donato Guerra", Abreviation = "Donato Guerra", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15033", Name = "Ecatepec de Morelos", Abreviation = "Ecatepec de Morelos", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15034", Name = "Ecatzingo", Abreviation = "Ecatzingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15035", Name = "Huehuetoca", Abreviation = "Huehuetoca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15036", Name = "Hueypoxtla", Abreviation = "Hueypoxtla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15037", Name = "Huixquilucan", Abreviation = "Huixquilucan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15038", Name = "Isidro Fabela", Abreviation = "Isidro Fabela", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15039", Name = "Ixtapaluca", Abreviation = "Ixtapaluca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15040", Name = "Ixtapan de la Sal", Abreviation = "Ixtapan de la Sal", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15041", Name = "Ixtapan del Oro", Abreviation = "Ixtapan del Oro", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15042", Name = "Ixtlahuaca", Abreviation = "Ixtlahuaca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15043", Name = "Xalatlaco", Abreviation = "Xalatlaco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15044", Name = "Jaltenco", Abreviation = "Jaltenco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15045", Name = "Jilotepec", Abreviation = "Jilotepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15046", Name = "Jilotzingo", Abreviation = "Jilotzingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15047", Name = "Jiquipilco", Abreviation = "Jiquipilco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15048", Name = "Jocotitlán", Abreviation = "Jocotitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15049", Name = "Joquicingo", Abreviation = "Joquicingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15050", Name = "Juchitepec", Abreviation = "Juchitepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15051", Name = "Lerma", Abreviation = "Lerma", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15052", Name = "Malinalco", Abreviation = "Malinalco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15053", Name = "Melchor Ocampo", Abreviation = "Melchor Ocampo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15054", Name = "Metepec", Abreviation = "Metepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15055", Name = "Mexicaltzingo", Abreviation = "Mexicaltzingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15056", Name = "Morelos", Abreviation = "Morelos", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15057", Name = "Naucalpan de Juárez", Abreviation = "Naucalpan de Juárez", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15058", Name = "Nezahualcóyotl", Abreviation = "Nezahualcóyotl", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15059", Name = "Nextlalpan", Abreviation = "Nextlalpan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15060", Name = "Nicolás Romero", Abreviation = "Nicolás Romero", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15061", Name = "Nopaltepec", Abreviation = "Nopaltepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15062", Name = "Ocoyoacac", Abreviation = "Ocoyoacac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15063", Name = "Ocuilan", Abreviation = "Ocuilan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15064", Name = "El Oro", Abreviation = "El Oro", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15065", Name = "Otumba", Abreviation = "Otumba", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15066", Name = "Otzoloapan", Abreviation = "Otzoloapan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15067", Name = "Otzolotepec", Abreviation = "Otzolotepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15068", Name = "Ozumba", Abreviation = "Ozumba", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15069", Name = "Papalotla", Abreviation = "Papalotla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15070", Name = "La Paz", Abreviation = "La Paz", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15071", Name = "Polotitlán", Abreviation = "Polotitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15072", Name = "Rayón", Abreviation = "Rayón", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15073", Name = "San Antonio la Isla", Abreviation = "San Antonio la Isla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15074", Name = "San Felipe del Progreso", Abreviation = "San Felipe del Progreso", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15075", Name = "San Martín de las Pirámides", Abreviation = "San Martín de las Pirámides", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15076", Name = "San Mateo Atenco", Abreviation = "San Mateo Atenco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15077", Name = "San Simón de Guerrero", Abreviation = "San Simón de Guerrero", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15078", Name = "Santo Tomás", Abreviation = "Santo Tomás", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15079", Name = "Soyaniquilpan de Juárez", Abreviation = "Soyaniquilpan de Juárez", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15080", Name = "Sultepec", Abreviation = "Sultepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15081", Name = "Tecámac", Abreviation = "Tecámac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15082", Name = "Tejupilco", Abreviation = "Tejupilco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15083", Name = "Temamatla", Abreviation = "Temamatla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15084", Name = "Temascalapa", Abreviation = "Temascalapa", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15085", Name = "Temascalcingo", Abreviation = "Temascalcingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15086", Name = "Temascaltepec", Abreviation = "Temascaltepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15087", Name = "Temoaya", Abreviation = "Temoaya", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15088", Name = "Tenancingo", Abreviation = "Tenancingo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15089", Name = "Tenango del Aire", Abreviation = "Tenango del Aire", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15090", Name = "Tenango del Valle", Abreviation = "Tenango del Valle", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15091", Name = "Teoloyucan", Abreviation = "Teoloyucan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15092", Name = "Teotihuacán", Abreviation = "Teotihuacán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15093", Name = "Tepetlaoxtoc", Abreviation = "Tepetlaoxtoc", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15094", Name = "Tepetlixpa", Abreviation = "Tepetlixpa", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15095", Name = "Tepotzotlán", Abreviation = "Tepotzotlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15096", Name = "Tequixquiac", Abreviation = "Tequixquiac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15097", Name = "Texcaltitlán", Abreviation = "Texcaltitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15098", Name = "Texcalyacac", Abreviation = "Texcalyacac", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15099", Name = "Texcoco", Abreviation = "Texcoco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15100", Name = "Tezoyuca", Abreviation = "Tezoyuca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15101", Name = "Tianguistenco", Abreviation = "Tianguistenco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15102", Name = "Timilpan", Abreviation = "Timilpan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15103", Name = "Tlalmanalco", Abreviation = "Tlalmanalco", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15104", Name = "Tlalnepantla de Baz", Abreviation = "Tlalnepantla de Baz", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15105", Name = "Tlatlaya", Abreviation = "Tlatlaya", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15106", Name = "Toluca", Abreviation = "Toluca", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15107", Name = "Tonatico", Abreviation = "Tonatico", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15108", Name = "Tultepec", Abreviation = "Tultepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15109", Name = "Tultitlán", Abreviation = "Tultitlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15110", Name = "Valle de Bravo", Abreviation = "Valle de Bravo", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15111", Name = "Villa de Allende", Abreviation = "Villa de Allende", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15112", Name = "Villa del Carbón", Abreviation = "Villa del Carbón", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15113", Name = "Villa Guerrero", Abreviation = "Villa Guerrero", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15114", Name = "Villa Victoria", Abreviation = "Villa Victoria", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15115", Name = "Xonacatlán", Abreviation = "Xonacatlán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15116", Name = "Zacazonapan", Abreviation = "Zacazonapan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15117", Name = "Zacualpan", Abreviation = "Zacualpan", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15118", Name = "Zinacantepec", Abreviation = "Zinacantepec", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15119", Name = "Zumpahuacán", Abreviation = "Zumpahuacán", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15120", Name = "Zumpango", Abreviation = "Zumpango", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15121", Name = "Cuautitlán Izcalli", Abreviation = "Cuautitlán Izcalli", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15122", Name = "Valle de Chalco Solidaridad", Abreviation = "Valle de Chalco Solidaridad", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15123", Name = "Luvianos", Abreviation = "Luvianos", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15124", Name = "San José del Rincón", Abreviation = "San José del Rincón", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "15125", Name = "Tonanitla", Abreviation = "Tonanitla", IsActive = true, StateId = "15" },
                    new Domain.City() { Id = "16001", Name = "Acuitzio", Abreviation = "Acuitzio", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16002", Name = "Aguililla", Abreviation = "Aguililla", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16003", Name = "Álvaro Obregón", Abreviation = "Álvaro Obregón", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16004", Name = "Angamacutiro", Abreviation = "Angamacutiro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16005", Name = "Angangueo", Abreviation = "Angangueo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16006", Name = "Apatzingán", Abreviation = "Apatzingán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16007", Name = "Aporo", Abreviation = "Aporo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16008", Name = "Aquila", Abreviation = "Aquila", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16009", Name = "Ario", Abreviation = "Ario", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16010", Name = "Arteaga", Abreviation = "Arteaga", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16011", Name = "Briseñas", Abreviation = "Briseñas", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16012", Name = "Buenavista", Abreviation = "Buenavista", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16013", Name = "Carácuaro", Abreviation = "Carácuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16014", Name = "Coahuayana", Abreviation = "Coahuayana", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16015", Name = "Coalcomán de Vázquez Pallares", Abreviation = "Coalcomán de Vázquez Pallares", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16016", Name = "Coeneo", Abreviation = "Coeneo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16017", Name = "Contepec", Abreviation = "Contepec", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16018", Name = "Copándaro", Abreviation = "Copándaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16019", Name = "Cotija", Abreviation = "Cotija", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16020", Name = "Cuitzeo", Abreviation = "Cuitzeo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16021", Name = "Charapan", Abreviation = "Charapan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16022", Name = "Charo", Abreviation = "Charo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16023", Name = "Chavinda", Abreviation = "Chavinda", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16024", Name = "Cherán", Abreviation = "Cherán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16025", Name = "Chilchota", Abreviation = "Chilchota", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16026", Name = "Chinicuila", Abreviation = "Chinicuila", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16027", Name = "Chucándiro", Abreviation = "Chucándiro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16028", Name = "Churintzio", Abreviation = "Churintzio", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16029", Name = "Churumuco", Abreviation = "Churumuco", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16030", Name = "Ecuandureo", Abreviation = "Ecuandureo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16031", Name = "Epitacio Huerta", Abreviation = "Epitacio Huerta", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16032", Name = "Erongarícuaro", Abreviation = "Erongarícuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16033", Name = "Gabriel Zamora", Abreviation = "Gabriel Zamora", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16034", Name = "Hidalgo", Abreviation = "Hidalgo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16035", Name = "La Huacana", Abreviation = "La Huacana", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16036", Name = "Huandacareo", Abreviation = "Huandacareo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16037", Name = "Huaniqueo", Abreviation = "Huaniqueo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16038", Name = "Huetamo", Abreviation = "Huetamo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16039", Name = "Huiramba", Abreviation = "Huiramba", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16040", Name = "Indaparapeo", Abreviation = "Indaparapeo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16041", Name = "Irimbo", Abreviation = "Irimbo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16042", Name = "Ixtlán", Abreviation = "Ixtlán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16043", Name = "Jacona", Abreviation = "Jacona", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16044", Name = "Jiménez", Abreviation = "Jiménez", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16045", Name = "Jiquilpan", Abreviation = "Jiquilpan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16046", Name = "Juárez", Abreviation = "Juárez", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16047", Name = "Jungapeo", Abreviation = "Jungapeo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16048", Name = "Lagunillas", Abreviation = "Lagunillas", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16049", Name = "Madero", Abreviation = "Madero", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16050", Name = "Maravatío", Abreviation = "Maravatío", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16051", Name = "Marcos Castellanos", Abreviation = "Marcos Castellanos", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16052", Name = "Lázaro Cárdenas", Abreviation = "Lázaro Cárdenas", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16053", Name = "Morelia", Abreviation = "Morelia", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16054", Name = "Morelos", Abreviation = "Morelos", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16055", Name = "Múgica", Abreviation = "Múgica", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16056", Name = "Nahuatzen", Abreviation = "Nahuatzen", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16057", Name = "Nocupétaro", Abreviation = "Nocupétaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16058", Name = "Nuevo Parangaricutiro", Abreviation = "Nuevo Parangaricutiro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16059", Name = "Nuevo Urecho", Abreviation = "Nuevo Urecho", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16060", Name = "Numarán", Abreviation = "Numarán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16061", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16062", Name = "Pajacuarán", Abreviation = "Pajacuarán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16063", Name = "Panindícuaro", Abreviation = "Panindícuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16064", Name = "Parácuaro", Abreviation = "Parácuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16065", Name = "Paracho", Abreviation = "Paracho", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16066", Name = "Pátzcuaro", Abreviation = "Pátzcuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16067", Name = "Penjamillo", Abreviation = "Penjamillo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16068", Name = "Peribán", Abreviation = "Peribán", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16069", Name = "La Piedad", Abreviation = "La Piedad", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16070", Name = "Purépero", Abreviation = "Purépero", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16071", Name = "Puruándiro", Abreviation = "Puruándiro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16072", Name = "Queréndaro", Abreviation = "Queréndaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16073", Name = "Quiroga", Abreviation = "Quiroga", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16074", Name = "Cojumatlán de Régules", Abreviation = "Cojumatlán de Régules", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16075", Name = "Los Reyes", Abreviation = "Los Reyes", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16076", Name = "Sahuayo", Abreviation = "Sahuayo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16077", Name = "San Lucas", Abreviation = "San Lucas", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16078", Name = "Santa Ana Maya", Abreviation = "Santa Ana Maya", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16079", Name = "Salvador Escalante", Abreviation = "Salvador Escalante", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16080", Name = "Senguio", Abreviation = "Senguio", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16081", Name = "Susupuato", Abreviation = "Susupuato", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16082", Name = "Tacámbaro", Abreviation = "Tacámbaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16083", Name = "Tancítaro", Abreviation = "Tancítaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16084", Name = "Tangamandapio", Abreviation = "Tangamandapio", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16085", Name = "Tangancícuaro", Abreviation = "Tangancícuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16086", Name = "Tanhuato", Abreviation = "Tanhuato", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16087", Name = "Taretan", Abreviation = "Taretan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16088", Name = "Tarímbaro", Abreviation = "Tarímbaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16089", Name = "Tepalcatepec", Abreviation = "Tepalcatepec", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16090", Name = "Tingambato", Abreviation = "Tingambato", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16091", Name = "Tingüindín", Abreviation = "Tingüindín", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16092", Name = "Tiquicheo de Nicolás Romero", Abreviation = "Tiquicheo de Nicolás Romero", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16093", Name = "Tlalpujahua", Abreviation = "Tlalpujahua", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16094", Name = "Tlazazalca", Abreviation = "Tlazazalca", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16095", Name = "Tocumbo", Abreviation = "Tocumbo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16096", Name = "Tumbiscatío", Abreviation = "Tumbiscatío", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16097", Name = "Turicato", Abreviation = "Turicato", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16098", Name = "Tuxpan", Abreviation = "Tuxpan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16099", Name = "Tuzantla", Abreviation = "Tuzantla", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16100", Name = "Tzintzuntzan", Abreviation = "Tzintzuntzan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16101", Name = "Tzitzio", Abreviation = "Tzitzio", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16102", Name = "Uruapan", Abreviation = "Uruapan", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16103", Name = "Venustiano Carranza", Abreviation = "Venustiano Carranza", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16104", Name = "Villamar", Abreviation = "Villamar", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16105", Name = "Vista Hermosa", Abreviation = "Vista Hermosa", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16106", Name = "Yurécuaro", Abreviation = "Yurécuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16107", Name = "Zacapu", Abreviation = "Zacapu", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16108", Name = "Zamora", Abreviation = "Zamora", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16109", Name = "Zináparo", Abreviation = "Zináparo", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16110", Name = "Zinapécuaro", Abreviation = "Zinapécuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16111", Name = "Ziracuaretiro", Abreviation = "Ziracuaretiro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16112", Name = "Zitácuaro", Abreviation = "Zitácuaro", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "16113", Name = "José Sixto Verduzco", Abreviation = "José Sixto Verduzco", IsActive = true, StateId = "16" },
                    new Domain.City() { Id = "17001", Name = "Amacuzac", Abreviation = "Amacuzac", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17002", Name = "Atlatlahucan", Abreviation = "Atlatlahucan", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17003", Name = "Axochiapan", Abreviation = "Axochiapan", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17004", Name = "Ayala", Abreviation = "Ayala", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17005", Name = "Coatlán del Río", Abreviation = "Coatlán del Río", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17006", Name = "Cuautla", Abreviation = "Cuautla", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17007", Name = "Cuernavaca", Abreviation = "Cuernavaca", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17008", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17009", Name = "Huitzilac", Abreviation = "Huitzilac", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17010", Name = "Jantetelco", Abreviation = "Jantetelco", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17011", Name = "Jiutepec", Abreviation = "Jiutepec", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17012", Name = "Jojutla", Abreviation = "Jojutla", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17013", Name = "Jonacatepec de Leandro Valle", Abreviation = "Jonacatepec de Leandro Valle", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17014", Name = "Mazatepec", Abreviation = "Mazatepec", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17015", Name = "Miacatlán", Abreviation = "Miacatlán", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17016", Name = "Ocuituco", Abreviation = "Ocuituco", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17017", Name = "Puente de Ixtla", Abreviation = "Puente de Ixtla", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17018", Name = "Temixco", Abreviation = "Temixco", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17019", Name = "Tepalcingo", Abreviation = "Tepalcingo", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17020", Name = "Tepoztlán", Abreviation = "Tepoztlán", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17021", Name = "Tetecala", Abreviation = "Tetecala", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17022", Name = "Tetela del Volcán", Abreviation = "Tetela del Volcán", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17023", Name = "Tlalnepantla", Abreviation = "Tlalnepantla", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17024", Name = "Tlaltizapán de Zapata", Abreviation = "Tlaltizapán de Zapata", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17025", Name = "Tlaquiltenango", Abreviation = "Tlaquiltenango", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17026", Name = "Tlayacapan", Abreviation = "Tlayacapan", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17027", Name = "Totolapan", Abreviation = "Totolapan", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17028", Name = "Xochitepec", Abreviation = "Xochitepec", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17029", Name = "Yautepec", Abreviation = "Yautepec", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17030", Name = "Yecapixtla", Abreviation = "Yecapixtla", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17031", Name = "Zacatepec", Abreviation = "Zacatepec", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17032", Name = "Zacualpan de Amilpas", Abreviation = "Zacualpan de Amilpas", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "17033", Name = "Temoac", Abreviation = "Temoac", IsActive = true, StateId = "17" },
                    new Domain.City() { Id = "18001", Name = "Acaponeta", Abreviation = "Acaponeta", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18002", Name = "Ahuacatlán", Abreviation = "Ahuacatlán", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18003", Name = "Amatlán de Cañas", Abreviation = "Amatlán de Cañas", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18004", Name = "Compostela", Abreviation = "Compostela", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18005", Name = "Huajicori", Abreviation = "Huajicori", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18006", Name = "Ixtlán del Río", Abreviation = "Ixtlán del Río", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18007", Name = "Jala", Abreviation = "Jala", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18008", Name = "Xalisco", Abreviation = "Xalisco", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18009", Name = "Del Nayar", Abreviation = "Del Nayar", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18010", Name = "Rosamorada", Abreviation = "Rosamorada", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18011", Name = "Ruíz", Abreviation = "Ruíz", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18012", Name = "San Blas", Abreviation = "San Blas", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18013", Name = "San Pedro Lagunillas", Abreviation = "San Pedro Lagunillas", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18014", Name = "Santa María del Oro", Abreviation = "Santa María del Oro", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18015", Name = "Santiago Ixcuintla", Abreviation = "Santiago Ixcuintla", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18016", Name = "Tecuala", Abreviation = "Tecuala", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18017", Name = "Tepic", Abreviation = "Tepic", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18018", Name = "Tuxpan", Abreviation = "Tuxpan", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18019", Name = "La Yesca", Abreviation = "La Yesca", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "18020", Name = "Bahía de Banderas", Abreviation = "Bahía de Banderas", IsActive = true, StateId = "18" },
                    new Domain.City() { Id = "19001", Name = "Abasolo", Abreviation = "Abasolo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19002", Name = "Agualeguas", Abreviation = "Agualeguas", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19003", Name = "Los Aldamas", Abreviation = "Los Aldamas", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19004", Name = "Allende", Abreviation = "Allende", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19005", Name = "Anáhuac", Abreviation = "Anáhuac", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19006", Name = "Apodaca", Abreviation = "Apodaca", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19007", Name = "Aramberri", Abreviation = "Aramberri", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19008", Name = "Bustamante", Abreviation = "Bustamante", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19009", Name = "Cadereyta Jiménez", Abreviation = "Cadereyta Jiménez", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19010", Name = "El Carmen", Abreviation = "El Carmen", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19011", Name = "Cerralvo", Abreviation = "Cerralvo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19012", Name = "Ciénega de Flores", Abreviation = "Ciénega de Flores", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19013", Name = "China", Abreviation = "China", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19014", Name = "Doctor Arroyo", Abreviation = "Doctor Arroyo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19015", Name = "Doctor Coss", Abreviation = "Doctor Coss", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19016", Name = "Doctor González", Abreviation = "Doctor González", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19017", Name = "Galeana", Abreviation = "Galeana", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19018", Name = "García", Abreviation = "García", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19019", Name = "San Pedro Garza García", Abreviation = "San Pedro Garza García", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19020", Name = "General Bravo", Abreviation = "General Bravo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19021", Name = "General Escobedo", Abreviation = "General Escobedo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19022", Name = "General Terán", Abreviation = "General Terán", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19023", Name = "General Treviño", Abreviation = "General Treviño", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19024", Name = "General Zaragoza", Abreviation = "General Zaragoza", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19025", Name = "General Zuazua", Abreviation = "General Zuazua", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19026", Name = "Guadalupe", Abreviation = "Guadalupe", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19027", Name = "Los Herreras", Abreviation = "Los Herreras", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19028", Name = "Higueras", Abreviation = "Higueras", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19029", Name = "Hualahuises", Abreviation = "Hualahuises", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19030", Name = "Iturbide", Abreviation = "Iturbide", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19031", Name = "Juárez", Abreviation = "Juárez", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19032", Name = "Lampazos de Naranjo", Abreviation = "Lampazos de Naranjo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19033", Name = "Linares", Abreviation = "Linares", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19034", Name = "Marín", Abreviation = "Marín", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19035", Name = "Melchor Ocampo", Abreviation = "Melchor Ocampo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19036", Name = "Mier y Noriega", Abreviation = "Mier y Noriega", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19037", Name = "Mina", Abreviation = "Mina", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19038", Name = "Montemorelos", Abreviation = "Montemorelos", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19039", Name = "Monterrey", Abreviation = "Monterrey", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19040", Name = "Parás", Abreviation = "Parás", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19041", Name = "Pesquería", Abreviation = "Pesquería", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19042", Name = "Los Ramones", Abreviation = "Los Ramones", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19043", Name = "Rayones", Abreviation = "Rayones", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19044", Name = "Sabinas Hidalgo", Abreviation = "Sabinas Hidalgo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19045", Name = "Salinas Victoria", Abreviation = "Salinas Victoria", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19046", Name = "San Nicolás de los Garza", Abreviation = "San Nicolás de los Garza", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19047", Name = "Hidalgo", Abreviation = "Hidalgo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19048", Name = "Santa Catarina", Abreviation = "Santa Catarina", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19049", Name = "Santiago", Abreviation = "Santiago", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19050", Name = "Vallecillo", Abreviation = "Vallecillo", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "19051", Name = "Villaldama", Abreviation = "Villaldama", IsActive = true, StateId = "19" },
                    new Domain.City() { Id = "20001", Name = "Abejones", Abreviation = "Abejones", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20002", Name = "Acatlán de Pérez Figueroa", Abreviation = "Acatlán de Pérez Figueroa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20003", Name = "Asunción Cacalotepec", Abreviation = "Asunción Cacalotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20004", Name = "Asunción Cuyotepeji", Abreviation = "Asunción Cuyotepeji", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20005", Name = "Asunción Ixtaltepec", Abreviation = "Asunción Ixtaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20006", Name = "Asunción Nochixtlán", Abreviation = "Asunción Nochixtlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20007", Name = "Asunción Ocotlán", Abreviation = "Asunción Ocotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20008", Name = "Asunción Tlacolulita", Abreviation = "Asunción Tlacolulita", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20009", Name = "Ayotzintepec", Abreviation = "Ayotzintepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20010", Name = "El Barrio de la Soledad", Abreviation = "El Barrio de la Soledad", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20011", Name = "Calihualá", Abreviation = "Calihualá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20012", Name = "Candelaria Loxicha", Abreviation = "Candelaria Loxicha", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20013", Name = "Ciénega de Zimatlán", Abreviation = "Ciénega de Zimatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20014", Name = "Ciudad Ixtepec", Abreviation = "Ciudad Ixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20015", Name = "Coatecas Altas", Abreviation = "Coatecas Altas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20016", Name = "Coicoyán de las Flores", Abreviation = "Coicoyán de las Flores", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20017", Name = "La Compañía", Abreviation = "La Compañía", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20018", Name = "Concepción Buenavista", Abreviation = "Concepción Buenavista", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20019", Name = "Concepción Pápalo", Abreviation = "Concepción Pápalo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20020", Name = "Constancia del Rosario", Abreviation = "Constancia del Rosario", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20021", Name = "Cosolapa", Abreviation = "Cosolapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20022", Name = "Cosoltepec", Abreviation = "Cosoltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20023", Name = "Cuilápam de Guerrero", Abreviation = "Cuilápam de Guerrero", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20024", Name = "Cuyamecalco Villa de Zaragoza", Abreviation = "Cuyamecalco Villa de Zaragoza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20025", Name = "Chahuites", Abreviation = "Chahuites", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20026", Name = "Chalcatongo de Hidalgo", Abreviation = "Chalcatongo de Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20027", Name = "Chiquihuitlán de Benito Juárez", Abreviation = "Chiquihuitlán de Benito Juárez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20028", Name = "Heroica Ciudad de Ejutla de Crespo", Abreviation = "Heroica Ciudad de Ejutla de Crespo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20029", Name = "Eloxochitlán de Flores Magón", Abreviation = "Eloxochitlán de Flores Magón", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20030", Name = "El Espinal", Abreviation = "El Espinal", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20031", Name = "Tamazulápam del Espíritu Santo", Abreviation = "Tamazulápam del Espíritu Santo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20032", Name = "Fresnillo de Trujano", Abreviation = "Fresnillo de Trujano", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20033", Name = "Guadalupe Etla", Abreviation = "Guadalupe Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20034", Name = "Guadalupe de Ramírez", Abreviation = "Guadalupe de Ramírez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20035", Name = "Guelatao de Juárez", Abreviation = "Guelatao de Juárez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20036", Name = "Guevea de Humboldt", Abreviation = "Guevea de Humboldt", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20037", Name = "Mesones Hidalgo", Abreviation = "Mesones Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20038", Name = "Villa Hidalgo", Abreviation = "Villa Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20039", Name = "Heroica Ciudad de Huajuapan de León", Abreviation = "Heroica Ciudad de Huajuapan de León", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20040", Name = "Huautepec", Abreviation = "Huautepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20041", Name = "Huautla de Jiménez", Abreviation = "Huautla de Jiménez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20042", Name = "Ixtlán de Juárez", Abreviation = "Ixtlán de Juárez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20043", Name = "Heroica Ciudad de Juchitán de Zaragoza", Abreviation = "Heroica Ciudad de Juchitán de Zaragoza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20044", Name = "Loma Bonita", Abreviation = "Loma Bonita", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20045", Name = "Magdalena Apasco", Abreviation = "Magdalena Apasco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20046", Name = "Magdalena Jaltepec", Abreviation = "Magdalena Jaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20047", Name = "Santa Magdalena Jicotlán", Abreviation = "Santa Magdalena Jicotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20048", Name = "Magdalena Mixtepec", Abreviation = "Magdalena Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20049", Name = "Magdalena Ocotlán", Abreviation = "Magdalena Ocotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20050", Name = "Magdalena Peñasco", Abreviation = "Magdalena Peñasco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20051", Name = "Magdalena Teitipac", Abreviation = "Magdalena Teitipac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20052", Name = "Magdalena Tequisistlán", Abreviation = "Magdalena Tequisistlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20053", Name = "Magdalena Tlacotepec", Abreviation = "Magdalena Tlacotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20054", Name = "Magdalena Zahuatlán", Abreviation = "Magdalena Zahuatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20055", Name = "Mariscala de Juárez", Abreviation = "Mariscala de Juárez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20056", Name = "Mártires de Tacubaya", Abreviation = "Mártires de Tacubaya", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20057", Name = "Matías Romero Avendaño", Abreviation = "Matías Romero Avendaño", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20058", Name = "Mazatlán Villa de Flores", Abreviation = "Mazatlán Villa de Flores", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20059", Name = "Miahuatlán de Porfirio Díaz", Abreviation = "Miahuatlán de Porfirio Díaz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20060", Name = "Mixistlán de la Reforma", Abreviation = "Mixistlán de la Reforma", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20061", Name = "Monjas", Abreviation = "Monjas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20062", Name = "Natividad", Abreviation = "Natividad", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20063", Name = "Nazareno Etla", Abreviation = "Nazareno Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20064", Name = "Nejapa de Madero", Abreviation = "Nejapa de Madero", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20065", Name = "Ixpantepec Nieves", Abreviation = "Ixpantepec Nieves", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20066", Name = "Santiago Niltepec", Abreviation = "Santiago Niltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20067", Name = "Oaxaca de Juárez", Abreviation = "Oaxaca de Juárez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20068", Name = "Ocotlán de Morelos", Abreviation = "Ocotlán de Morelos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20069", Name = "La Pe", Abreviation = "La Pe", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20070", Name = "Pinotepa de Don Luis", Abreviation = "Pinotepa de Don Luis", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20071", Name = "Pluma Hidalgo", Abreviation = "Pluma Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20072", Name = "San José del Progreso", Abreviation = "San José del Progreso", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20073", Name = "Putla Villa de Guerrero", Abreviation = "Putla Villa de Guerrero", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20074", Name = "Santa Catarina Quioquitani", Abreviation = "Santa Catarina Quioquitani", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20075", Name = "Reforma de Pineda", Abreviation = "Reforma de Pineda", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20076", Name = "La Reforma", Abreviation = "La Reforma", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20077", Name = "Reyes Etla", Abreviation = "Reyes Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20078", Name = "Rojas de Cuauhtémoc", Abreviation = "Rojas de Cuauhtémoc", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20079", Name = "Salina Cruz", Abreviation = "Salina Cruz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20080", Name = "San Agustín Amatengo", Abreviation = "San Agustín Amatengo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20081", Name = "San Agustín Atenango", Abreviation = "San Agustín Atenango", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20082", Name = "San Agustín Chayuco", Abreviation = "San Agustín Chayuco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20083", Name = "San Agustín de las Juntas", Abreviation = "San Agustín de las Juntas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20084", Name = "San Agustín Etla", Abreviation = "San Agustín Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20085", Name = "San Agustín Loxicha", Abreviation = "San Agustín Loxicha", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20086", Name = "San Agustín Tlacotepec", Abreviation = "San Agustín Tlacotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20087", Name = "San Agustín Yatareni", Abreviation = "San Agustín Yatareni", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20088", Name = "San Andrés Cabecera Nueva", Abreviation = "San Andrés Cabecera Nueva", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20089", Name = "San Andrés Dinicuiti", Abreviation = "San Andrés Dinicuiti", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20090", Name = "San Andrés Huaxpaltepec", Abreviation = "San Andrés Huaxpaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20091", Name = "San Andrés Huayápam", Abreviation = "San Andrés Huayápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20092", Name = "San Andrés Ixtlahuaca", Abreviation = "San Andrés Ixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20093", Name = "San Andrés Lagunas", Abreviation = "San Andrés Lagunas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20094", Name = "San Andrés Nuxiño", Abreviation = "San Andrés Nuxiño", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20095", Name = "San Andrés Paxtlán", Abreviation = "San Andrés Paxtlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20096", Name = "San Andrés Sinaxtla", Abreviation = "San Andrés Sinaxtla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20097", Name = "San Andrés Solaga", Abreviation = "San Andrés Solaga", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20098", Name = "San Andrés Teotilálpam", Abreviation = "San Andrés Teotilálpam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20099", Name = "San Andrés Tepetlapa", Abreviation = "San Andrés Tepetlapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20100", Name = "San Andrés Yaá", Abreviation = "San Andrés Yaá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20101", Name = "San Andrés Zabache", Abreviation = "San Andrés Zabache", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20102", Name = "San Andrés Zautla", Abreviation = "San Andrés Zautla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20103", Name = "San Antonino Castillo Velasco", Abreviation = "San Antonino Castillo Velasco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20104", Name = "San Antonino el Alto", Abreviation = "San Antonino el Alto", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20105", Name = "San Antonino Monte Verde", Abreviation = "San Antonino Monte Verde", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20106", Name = "San Antonio Acutla", Abreviation = "San Antonio Acutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20107", Name = "San Antonio de la Cal", Abreviation = "San Antonio de la Cal", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20108", Name = "San Antonio Huitepec", Abreviation = "San Antonio Huitepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20109", Name = "San Antonio Nanahuatípam", Abreviation = "San Antonio Nanahuatípam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20110", Name = "San Antonio Sinicahua", Abreviation = "San Antonio Sinicahua", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20111", Name = "San Antonio Tepetlapa", Abreviation = "San Antonio Tepetlapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20112", Name = "San Baltazar Chichicápam", Abreviation = "San Baltazar Chichicápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20113", Name = "San Baltazar Loxicha", Abreviation = "San Baltazar Loxicha", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20114", Name = "San Baltazar Yatzachi el Bajo", Abreviation = "San Baltazar Yatzachi el Bajo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20115", Name = "San Bartolo Coyotepec", Abreviation = "San Bartolo Coyotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20116", Name = "San Bartolomé Ayautla", Abreviation = "San Bartolomé Ayautla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20117", Name = "San Bartolomé Loxicha", Abreviation = "San Bartolomé Loxicha", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20118", Name = "San Bartolomé Quialana", Abreviation = "San Bartolomé Quialana", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20119", Name = "San Bartolomé Yucuañe", Abreviation = "San Bartolomé Yucuañe", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20120", Name = "San Bartolomé Zoogocho", Abreviation = "San Bartolomé Zoogocho", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20121", Name = "San Bartolo Soyaltepec", Abreviation = "San Bartolo Soyaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20122", Name = "San Bartolo Yautepec", Abreviation = "San Bartolo Yautepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20123", Name = "San Bernardo Mixtepec", Abreviation = "San Bernardo Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20124", Name = "San Blas Atempa", Abreviation = "San Blas Atempa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20125", Name = "San Carlos Yautepec", Abreviation = "San Carlos Yautepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20126", Name = "San Cristóbal Amatlán", Abreviation = "San Cristóbal Amatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20127", Name = "San Cristóbal Amoltepec", Abreviation = "San Cristóbal Amoltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20128", Name = "San Cristóbal Lachirioag", Abreviation = "San Cristóbal Lachirioag", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20129", Name = "San Cristóbal Suchixtlahuaca", Abreviation = "San Cristóbal Suchixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20130", Name = "San Dionisio del Mar", Abreviation = "San Dionisio del Mar", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20131", Name = "San Dionisio Ocotepec", Abreviation = "San Dionisio Ocotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20132", Name = "San Dionisio Ocotlán", Abreviation = "San Dionisio Ocotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20133", Name = "San Esteban Atatlahuca", Abreviation = "San Esteban Atatlahuca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20134", Name = "San Felipe Jalapa de Díaz", Abreviation = "San Felipe Jalapa de Díaz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20135", Name = "San Felipe Tejalápam", Abreviation = "San Felipe Tejalápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20136", Name = "San Felipe Usila", Abreviation = "San Felipe Usila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20137", Name = "San Francisco Cahuacuá", Abreviation = "San Francisco Cahuacuá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20138", Name = "San Francisco Cajonos", Abreviation = "San Francisco Cajonos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20139", Name = "San Francisco Chapulapa", Abreviation = "San Francisco Chapulapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20140", Name = "San Francisco Chindúa", Abreviation = "San Francisco Chindúa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20141", Name = "San Francisco del Mar", Abreviation = "San Francisco del Mar", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20142", Name = "San Francisco Huehuetlán", Abreviation = "San Francisco Huehuetlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20143", Name = "San Francisco Ixhuatán", Abreviation = "San Francisco Ixhuatán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20144", Name = "San Francisco Jaltepetongo", Abreviation = "San Francisco Jaltepetongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20145", Name = "San Francisco Lachigoló", Abreviation = "San Francisco Lachigoló", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20146", Name = "San Francisco Logueche", Abreviation = "San Francisco Logueche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20147", Name = "San Francisco Nuxaño", Abreviation = "San Francisco Nuxaño", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20148", Name = "San Francisco Ozolotepec", Abreviation = "San Francisco Ozolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20149", Name = "San Francisco Sola", Abreviation = "San Francisco Sola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20150", Name = "San Francisco Telixtlahuaca", Abreviation = "San Francisco Telixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20151", Name = "San Francisco Teopan", Abreviation = "San Francisco Teopan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20152", Name = "San Francisco Tlapancingo", Abreviation = "San Francisco Tlapancingo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20153", Name = "San Gabriel Mixtepec", Abreviation = "San Gabriel Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20154", Name = "San Ildefonso Amatlán", Abreviation = "San Ildefonso Amatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20155", Name = "San Ildefonso Sola", Abreviation = "San Ildefonso Sola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20156", Name = "San Ildefonso Villa Alta", Abreviation = "San Ildefonso Villa Alta", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20157", Name = "San Jacinto Amilpas", Abreviation = "San Jacinto Amilpas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20158", Name = "San Jacinto Tlacotepec", Abreviation = "San Jacinto Tlacotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20159", Name = "San Jerónimo Coatlán", Abreviation = "San Jerónimo Coatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20160", Name = "San Jerónimo Silacayoapilla", Abreviation = "San Jerónimo Silacayoapilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20161", Name = "San Jerónimo Sosola", Abreviation = "San Jerónimo Sosola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20162", Name = "San Jerónimo Taviche", Abreviation = "San Jerónimo Taviche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20163", Name = "San Jerónimo Tecóatl", Abreviation = "San Jerónimo Tecóatl", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20164", Name = "San Jorge Nuchita", Abreviation = "San Jorge Nuchita", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20165", Name = "San José Ayuquila", Abreviation = "San José Ayuquila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20166", Name = "San José Chiltepec", Abreviation = "San José Chiltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20167", Name = "San José del Peñasco", Abreviation = "San José del Peñasco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20168", Name = "San José Estancia Grande", Abreviation = "San José Estancia Grande", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20169", Name = "San José Independencia", Abreviation = "San José Independencia", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20170", Name = "San José Lachiguiri", Abreviation = "San José Lachiguiri", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20171", Name = "San José Tenango", Abreviation = "San José Tenango", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20172", Name = "San Juan Achiutla", Abreviation = "San Juan Achiutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20173", Name = "San Juan Atepec", Abreviation = "San Juan Atepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20174", Name = "Ánimas Trujano", Abreviation = "Ánimas Trujano", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20175", Name = "San Juan Bautista Atatlahuca", Abreviation = "San Juan Bautista Atatlahuca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20176", Name = "San Juan Bautista Coixtlahuaca", Abreviation = "San Juan Bautista Coixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20177", Name = "San Juan Bautista Cuicatlán", Abreviation = "San Juan Bautista Cuicatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20178", Name = "San Juan Bautista Guelache", Abreviation = "San Juan Bautista Guelache", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20179", Name = "San Juan Bautista Jayacatlán", Abreviation = "San Juan Bautista Jayacatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20180", Name = "San Juan Bautista Lo de Soto", Abreviation = "San Juan Bautista Lo de Soto", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20181", Name = "San Juan Bautista Suchitepec", Abreviation = "San Juan Bautista Suchitepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20182", Name = "San Juan Bautista Tlacoatzintepec", Abreviation = "San Juan Bautista Tlacoatzintepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20183", Name = "San Juan Bautista Tlachichilco", Abreviation = "San Juan Bautista Tlachichilco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20184", Name = "San Juan Bautista Tuxtepec", Abreviation = "San Juan Bautista Tuxtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20185", Name = "San Juan Cacahuatepec", Abreviation = "San Juan Cacahuatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20186", Name = "San Juan Cieneguilla", Abreviation = "San Juan Cieneguilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20187", Name = "San Juan Coatzóspam", Abreviation = "San Juan Coatzóspam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20188", Name = "San Juan Colorado", Abreviation = "San Juan Colorado", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20189", Name = "San Juan Comaltepec", Abreviation = "San Juan Comaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20190", Name = "San Juan Cotzocón", Abreviation = "San Juan Cotzocón", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20191", Name = "San Juan Chicomezúchil", Abreviation = "San Juan Chicomezúchil", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20192", Name = "San Juan Chilateca", Abreviation = "San Juan Chilateca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20193", Name = "San Juan del Estado", Abreviation = "San Juan del Estado", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20194", Name = "San Juan del Río", Abreviation = "San Juan del Río", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20195", Name = "San Juan Diuxi", Abreviation = "San Juan Diuxi", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20196", Name = "San Juan Evangelista Analco", Abreviation = "San Juan Evangelista Analco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20197", Name = "San Juan Guelavía", Abreviation = "San Juan Guelavía", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20198", Name = "San Juan Guichicovi", Abreviation = "San Juan Guichicovi", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20199", Name = "San Juan Ihualtepec", Abreviation = "San Juan Ihualtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20200", Name = "San Juan Juquila Mixes", Abreviation = "San Juan Juquila Mixes", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20201", Name = "San Juan Juquila Vijanos", Abreviation = "San Juan Juquila Vijanos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20202", Name = "San Juan Lachao", Abreviation = "San Juan Lachao", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20203", Name = "San Juan Lachigalla", Abreviation = "San Juan Lachigalla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20204", Name = "San Juan Lajarcia", Abreviation = "San Juan Lajarcia", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20205", Name = "San Juan Lalana", Abreviation = "San Juan Lalana", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20206", Name = "San Juan de los Cués", Abreviation = "San Juan de los Cués", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20207", Name = "San Juan Mazatlán", Abreviation = "San Juan Mazatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20208", Name = "San Juan Mixtepec", Abreviation = "San Juan Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20209", Name = "San Juan Mixtepec", Abreviation = "San Juan Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20210", Name = "San Juan Ñumí", Abreviation = "San Juan Ñumí", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20211", Name = "San Juan Ozolotepec", Abreviation = "San Juan Ozolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20212", Name = "San Juan Petlapa", Abreviation = "San Juan Petlapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20213", Name = "San Juan Quiahije", Abreviation = "San Juan Quiahije", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20214", Name = "San Juan Quiotepec", Abreviation = "San Juan Quiotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20215", Name = "San Juan Sayultepec", Abreviation = "San Juan Sayultepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20216", Name = "San Juan Tabaá", Abreviation = "San Juan Tabaá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20217", Name = "San Juan Tamazola", Abreviation = "San Juan Tamazola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20218", Name = "San Juan Teita", Abreviation = "San Juan Teita", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20219", Name = "San Juan Teitipac", Abreviation = "San Juan Teitipac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20220", Name = "San Juan Tepeuxila", Abreviation = "San Juan Tepeuxila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20221", Name = "San Juan Teposcolula", Abreviation = "San Juan Teposcolula", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20222", Name = "San Juan Yaeé", Abreviation = "San Juan Yaeé", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20223", Name = "San Juan Yatzona", Abreviation = "San Juan Yatzona", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20224", Name = "San Juan Yucuita", Abreviation = "San Juan Yucuita", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20225", Name = "San Lorenzo", Abreviation = "San Lorenzo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20226", Name = "San Lorenzo Albarradas", Abreviation = "San Lorenzo Albarradas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20227", Name = "San Lorenzo Cacaotepec", Abreviation = "San Lorenzo Cacaotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20228", Name = "San Lorenzo Cuaunecuiltitla", Abreviation = "San Lorenzo Cuaunecuiltitla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20229", Name = "San Lorenzo Texmelúcan", Abreviation = "San Lorenzo Texmelúcan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20230", Name = "San Lorenzo Victoria", Abreviation = "San Lorenzo Victoria", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20231", Name = "San Lucas Camotlán", Abreviation = "San Lucas Camotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20232", Name = "San Lucas Ojitlán", Abreviation = "San Lucas Ojitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20233", Name = "San Lucas Quiaviní", Abreviation = "San Lucas Quiaviní", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20234", Name = "San Lucas Zoquiápam", Abreviation = "San Lucas Zoquiápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20235", Name = "San Luis Amatlán", Abreviation = "San Luis Amatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20236", Name = "San Marcial Ozolotepec", Abreviation = "San Marcial Ozolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20237", Name = "San Marcos Arteaga", Abreviation = "San Marcos Arteaga", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20238", Name = "San Martín de los Cansecos", Abreviation = "San Martín de los Cansecos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20239", Name = "San Martín Huamelúlpam", Abreviation = "San Martín Huamelúlpam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20240", Name = "San Martín Itunyoso", Abreviation = "San Martín Itunyoso", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20241", Name = "San Martín Lachilá", Abreviation = "San Martín Lachilá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20242", Name = "San Martín Peras", Abreviation = "San Martín Peras", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20243", Name = "San Martín Tilcajete", Abreviation = "San Martín Tilcajete", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20244", Name = "San Martín Toxpalan", Abreviation = "San Martín Toxpalan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20245", Name = "San Martín Zacatepec", Abreviation = "San Martín Zacatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20246", Name = "San Mateo Cajonos", Abreviation = "San Mateo Cajonos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20247", Name = "Capulálpam de Méndez", Abreviation = "Capulálpam de Méndez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20248", Name = "San Mateo del Mar", Abreviation = "San Mateo del Mar", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20249", Name = "San Mateo Yoloxochitlán", Abreviation = "San Mateo Yoloxochitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20250", Name = "San Mateo Etlatongo", Abreviation = "San Mateo Etlatongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20251", Name = "San Mateo Nejápam", Abreviation = "San Mateo Nejápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20252", Name = "San Mateo Peñasco", Abreviation = "San Mateo Peñasco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20253", Name = "San Mateo Piñas", Abreviation = "San Mateo Piñas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20254", Name = "San Mateo Río Hondo", Abreviation = "San Mateo Río Hondo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20255", Name = "San Mateo Sindihui", Abreviation = "San Mateo Sindihui", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20256", Name = "San Mateo Tlapiltepec", Abreviation = "San Mateo Tlapiltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20257", Name = "San Melchor Betaza", Abreviation = "San Melchor Betaza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20258", Name = "San Miguel Achiutla", Abreviation = "San Miguel Achiutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20259", Name = "San Miguel Ahuehuetitlán", Abreviation = "San Miguel Ahuehuetitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20260", Name = "San Miguel Aloápam", Abreviation = "San Miguel Aloápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20261", Name = "San Miguel Amatitlán", Abreviation = "San Miguel Amatitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20262", Name = "San Miguel Amatlán", Abreviation = "San Miguel Amatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20263", Name = "San Miguel Coatlán", Abreviation = "San Miguel Coatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20264", Name = "San Miguel Chicahua", Abreviation = "San Miguel Chicahua", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20265", Name = "San Miguel Chimalapa", Abreviation = "San Miguel Chimalapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20266", Name = "San Miguel del Puerto", Abreviation = "San Miguel del Puerto", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20267", Name = "San Miguel del Río", Abreviation = "San Miguel del Río", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20268", Name = "San Miguel Ejutla", Abreviation = "San Miguel Ejutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20269", Name = "San Miguel el Grande", Abreviation = "San Miguel el Grande", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20270", Name = "San Miguel Huautla", Abreviation = "San Miguel Huautla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20271", Name = "San Miguel Mixtepec", Abreviation = "San Miguel Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20272", Name = "San Miguel Panixtlahuaca", Abreviation = "San Miguel Panixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20273", Name = "San Miguel Peras", Abreviation = "San Miguel Peras", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20274", Name = "San Miguel Piedras", Abreviation = "San Miguel Piedras", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20275", Name = "San Miguel Quetzaltepec", Abreviation = "San Miguel Quetzaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20276", Name = "San Miguel Santa Flor", Abreviation = "San Miguel Santa Flor", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20277", Name = "Villa Sola de Vega", Abreviation = "Villa Sola de Vega", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20278", Name = "San Miguel Soyaltepec", Abreviation = "San Miguel Soyaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20279", Name = "San Miguel Suchixtepec", Abreviation = "San Miguel Suchixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20280", Name = "Villa Talea de Castro", Abreviation = "Villa Talea de Castro", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20281", Name = "San Miguel Tecomatlán", Abreviation = "San Miguel Tecomatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20282", Name = "San Miguel Tenango", Abreviation = "San Miguel Tenango", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20283", Name = "San Miguel Tequixtepec", Abreviation = "San Miguel Tequixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20284", Name = "San Miguel Tilquiápam", Abreviation = "San Miguel Tilquiápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20285", Name = "San Miguel Tlacamama", Abreviation = "San Miguel Tlacamama", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20286", Name = "San Miguel Tlacotepec", Abreviation = "San Miguel Tlacotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20287", Name = "San Miguel Tulancingo", Abreviation = "San Miguel Tulancingo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20288", Name = "San Miguel Yotao", Abreviation = "San Miguel Yotao", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20289", Name = "San Nicolás", Abreviation = "San Nicolás", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20290", Name = "San Nicolás Hidalgo", Abreviation = "San Nicolás Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20291", Name = "San Pablo Coatlán", Abreviation = "San Pablo Coatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20292", Name = "San Pablo Cuatro Venados", Abreviation = "San Pablo Cuatro Venados", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20293", Name = "San Pablo Etla", Abreviation = "San Pablo Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20294", Name = "San Pablo Huitzo", Abreviation = "San Pablo Huitzo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20295", Name = "San Pablo Huixtepec", Abreviation = "San Pablo Huixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20296", Name = "San Pablo Macuiltianguis", Abreviation = "San Pablo Macuiltianguis", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20297", Name = "San Pablo Tijaltepec", Abreviation = "San Pablo Tijaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20298", Name = "San Pablo Villa de Mitla", Abreviation = "San Pablo Villa de Mitla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20299", Name = "San Pablo Yaganiza", Abreviation = "San Pablo Yaganiza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20300", Name = "San Pedro Amuzgos", Abreviation = "San Pedro Amuzgos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20301", Name = "San Pedro Apóstol", Abreviation = "San Pedro Apóstol", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20302", Name = "San Pedro Atoyac", Abreviation = "San Pedro Atoyac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20303", Name = "San Pedro Cajonos", Abreviation = "San Pedro Cajonos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20304", Name = "San Pedro Coxcaltepec Cántaros", Abreviation = "San Pedro Coxcaltepec Cántaros", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20305", Name = "San Pedro Comitancillo", Abreviation = "San Pedro Comitancillo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20306", Name = "San Pedro el Alto", Abreviation = "San Pedro el Alto", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20307", Name = "San Pedro Huamelula", Abreviation = "San Pedro Huamelula", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20308", Name = "San Pedro Huilotepec", Abreviation = "San Pedro Huilotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20309", Name = "San Pedro Ixcatlán", Abreviation = "San Pedro Ixcatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20310", Name = "San Pedro Ixtlahuaca", Abreviation = "San Pedro Ixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20311", Name = "San Pedro Jaltepetongo", Abreviation = "San Pedro Jaltepetongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20312", Name = "San Pedro Jicayán", Abreviation = "San Pedro Jicayán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20313", Name = "San Pedro Jocotipac", Abreviation = "San Pedro Jocotipac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20314", Name = "San Pedro Juchatengo", Abreviation = "San Pedro Juchatengo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20315", Name = "San Pedro Mártir", Abreviation = "San Pedro Mártir", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20316", Name = "San Pedro Mártir Quiechapa", Abreviation = "San Pedro Mártir Quiechapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20317", Name = "San Pedro Mártir Yucuxaco", Abreviation = "San Pedro Mártir Yucuxaco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20318", Name = "San Pedro Mixtepec", Abreviation = "San Pedro Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20319", Name = "San Pedro Mixtepec", Abreviation = "San Pedro Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20320", Name = "San Pedro Molinos", Abreviation = "San Pedro Molinos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20321", Name = "San Pedro Nopala", Abreviation = "San Pedro Nopala", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20322", Name = "San Pedro Ocopetatillo", Abreviation = "San Pedro Ocopetatillo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20323", Name = "San Pedro Ocotepec", Abreviation = "San Pedro Ocotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20324", Name = "San Pedro Pochutla", Abreviation = "San Pedro Pochutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20325", Name = "San Pedro Quiatoni", Abreviation = "San Pedro Quiatoni", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20326", Name = "San Pedro Sochiápam", Abreviation = "San Pedro Sochiápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20327", Name = "San Pedro Tapanatepec", Abreviation = "San Pedro Tapanatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20328", Name = "San Pedro Taviche", Abreviation = "San Pedro Taviche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20329", Name = "San Pedro Teozacoalco", Abreviation = "San Pedro Teozacoalco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20330", Name = "San Pedro Teutila", Abreviation = "San Pedro Teutila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20331", Name = "San Pedro Tidaá", Abreviation = "San Pedro Tidaá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20332", Name = "San Pedro Topiltepec", Abreviation = "San Pedro Topiltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20333", Name = "San Pedro Totolápam", Abreviation = "San Pedro Totolápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20334", Name = "Villa de Tututepec", Abreviation = "Villa de Tututepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20335", Name = "San Pedro Yaneri", Abreviation = "San Pedro Yaneri", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20336", Name = "San Pedro Yólox", Abreviation = "San Pedro Yólox", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20337", Name = "San Pedro y San Pablo Ayutla", Abreviation = "San Pedro y San Pablo Ayutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20338", Name = "Villa de Etla", Abreviation = "Villa de Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20339", Name = "San Pedro y San Pablo Teposcolula", Abreviation = "San Pedro y San Pablo Teposcolula", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20340", Name = "San Pedro y San Pablo Tequixtepec", Abreviation = "San Pedro y San Pablo Tequixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20341", Name = "San Pedro Yucunama", Abreviation = "San Pedro Yucunama", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20342", Name = "San Raymundo Jalpan", Abreviation = "San Raymundo Jalpan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20343", Name = "San Sebastián Abasolo", Abreviation = "San Sebastián Abasolo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20344", Name = "San Sebastián Coatlán", Abreviation = "San Sebastián Coatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20345", Name = "San Sebastián Ixcapa", Abreviation = "San Sebastián Ixcapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20346", Name = "San Sebastián Nicananduta", Abreviation = "San Sebastián Nicananduta", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20347", Name = "San Sebastián Río Hondo", Abreviation = "San Sebastián Río Hondo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20348", Name = "San Sebastián Tecomaxtlahuaca", Abreviation = "San Sebastián Tecomaxtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20349", Name = "San Sebastián Teitipac", Abreviation = "San Sebastián Teitipac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20350", Name = "San Sebastián Tutla", Abreviation = "San Sebastián Tutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20351", Name = "San Simón Almolongas", Abreviation = "San Simón Almolongas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20352", Name = "San Simón Zahuatlán", Abreviation = "San Simón Zahuatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20353", Name = "Santa Ana", Abreviation = "Santa Ana", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20354", Name = "Santa Ana Ateixtlahuaca", Abreviation = "Santa Ana Ateixtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20355", Name = "Santa Ana Cuauhtémoc", Abreviation = "Santa Ana Cuauhtémoc", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20356", Name = "Santa Ana del Valle", Abreviation = "Santa Ana del Valle", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20357", Name = "Santa Ana Tavela", Abreviation = "Santa Ana Tavela", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20358", Name = "Santa Ana Tlapacoyan", Abreviation = "Santa Ana Tlapacoyan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20359", Name = "Santa Ana Yareni", Abreviation = "Santa Ana Yareni", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20360", Name = "Santa Ana Zegache", Abreviation = "Santa Ana Zegache", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20361", Name = "Santa Catalina Quierí", Abreviation = "Santa Catalina Quierí", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20362", Name = "Santa Catarina Cuixtla", Abreviation = "Santa Catarina Cuixtla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20363", Name = "Santa Catarina Ixtepeji", Abreviation = "Santa Catarina Ixtepeji", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20364", Name = "Santa Catarina Juquila", Abreviation = "Santa Catarina Juquila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20365", Name = "Santa Catarina Lachatao", Abreviation = "Santa Catarina Lachatao", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20366", Name = "Santa Catarina Loxicha", Abreviation = "Santa Catarina Loxicha", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20367", Name = "Santa Catarina Mechoacán", Abreviation = "Santa Catarina Mechoacán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20368", Name = "Santa Catarina Minas", Abreviation = "Santa Catarina Minas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20369", Name = "Santa Catarina Quiané", Abreviation = "Santa Catarina Quiané", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20370", Name = "Santa Catarina Tayata", Abreviation = "Santa Catarina Tayata", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20371", Name = "Santa Catarina Ticuá", Abreviation = "Santa Catarina Ticuá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20372", Name = "Santa Catarina Yosonotú", Abreviation = "Santa Catarina Yosonotú", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20373", Name = "Santa Catarina Zapoquila", Abreviation = "Santa Catarina Zapoquila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20374", Name = "Santa Cruz Acatepec", Abreviation = "Santa Cruz Acatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20375", Name = "Santa Cruz Amilpas", Abreviation = "Santa Cruz Amilpas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20376", Name = "Santa Cruz de Bravo", Abreviation = "Santa Cruz de Bravo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20377", Name = "Santa Cruz Itundujia", Abreviation = "Santa Cruz Itundujia", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20378", Name = "Santa Cruz Mixtepec", Abreviation = "Santa Cruz Mixtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20379", Name = "Santa Cruz Nundaco", Abreviation = "Santa Cruz Nundaco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20380", Name = "Santa Cruz Papalutla", Abreviation = "Santa Cruz Papalutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20381", Name = "Santa Cruz Tacache de Mina", Abreviation = "Santa Cruz Tacache de Mina", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20382", Name = "Santa Cruz Tacahua", Abreviation = "Santa Cruz Tacahua", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20383", Name = "Santa Cruz Tayata", Abreviation = "Santa Cruz Tayata", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20384", Name = "Santa Cruz Xitla", Abreviation = "Santa Cruz Xitla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20385", Name = "Santa Cruz Xoxocotlán", Abreviation = "Santa Cruz Xoxocotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20386", Name = "Santa Cruz Zenzontepec", Abreviation = "Santa Cruz Zenzontepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20387", Name = "Santa Gertrudis", Abreviation = "Santa Gertrudis", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20388", Name = "Santa Inés del Monte", Abreviation = "Santa Inés del Monte", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20389", Name = "Santa Inés Yatzeche", Abreviation = "Santa Inés Yatzeche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20390", Name = "Santa Lucía del Camino", Abreviation = "Santa Lucía del Camino", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20391", Name = "Santa Lucía Miahuatlán", Abreviation = "Santa Lucía Miahuatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20392", Name = "Santa Lucía Monteverde", Abreviation = "Santa Lucía Monteverde", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20393", Name = "Santa Lucía Ocotlán", Abreviation = "Santa Lucía Ocotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20394", Name = "Santa María Alotepec", Abreviation = "Santa María Alotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20395", Name = "Santa María Apazco", Abreviation = "Santa María Apazco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20396", Name = "Santa María la Asunción", Abreviation = "Santa María la Asunción", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20397", Name = "Heroica Ciudad de Tlaxiaco", Abreviation = "Heroica Ciudad de Tlaxiaco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20398", Name = "Ayoquezco de Aldama", Abreviation = "Ayoquezco de Aldama", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20399", Name = "Santa María Atzompa", Abreviation = "Santa María Atzompa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20400", Name = "Santa María Camotlán", Abreviation = "Santa María Camotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20401", Name = "Santa María Colotepec", Abreviation = "Santa María Colotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20402", Name = "Santa María Cortijo", Abreviation = "Santa María Cortijo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20403", Name = "Santa María Coyotepec", Abreviation = "Santa María Coyotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20404", Name = "Santa María Chachoápam", Abreviation = "Santa María Chachoápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20405", Name = "Villa de Chilapa de Díaz", Abreviation = "Villa de Chilapa de Díaz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20406", Name = "Santa María Chilchotla", Abreviation = "Santa María Chilchotla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20407", Name = "Santa María Chimalapa", Abreviation = "Santa María Chimalapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20408", Name = "Santa María del Rosario", Abreviation = "Santa María del Rosario", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20409", Name = "Santa María del Tule", Abreviation = "Santa María del Tule", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20410", Name = "Santa María Ecatepec", Abreviation = "Santa María Ecatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20411", Name = "Santa María Guelacé", Abreviation = "Santa María Guelacé", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20412", Name = "Santa María Guienagati", Abreviation = "Santa María Guienagati", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20413", Name = "Santa María Huatulco", Abreviation = "Santa María Huatulco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20414", Name = "Santa María Huazolotitlán", Abreviation = "Santa María Huazolotitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20415", Name = "Santa María Ipalapa", Abreviation = "Santa María Ipalapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20416", Name = "Santa María Ixcatlán", Abreviation = "Santa María Ixcatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20417", Name = "Santa María Jacatepec", Abreviation = "Santa María Jacatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20418", Name = "Santa María Jalapa del Marqués", Abreviation = "Santa María Jalapa del Marqués", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20419", Name = "Santa María Jaltianguis", Abreviation = "Santa María Jaltianguis", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20420", Name = "Santa María Lachixío", Abreviation = "Santa María Lachixío", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20421", Name = "Santa María Mixtequilla", Abreviation = "Santa María Mixtequilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20422", Name = "Santa María Nativitas", Abreviation = "Santa María Nativitas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20423", Name = "Santa María Nduayaco", Abreviation = "Santa María Nduayaco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20424", Name = "Santa María Ozolotepec", Abreviation = "Santa María Ozolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20425", Name = "Santa María Pápalo", Abreviation = "Santa María Pápalo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20426", Name = "Santa María Peñoles", Abreviation = "Santa María Peñoles", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20427", Name = "Santa María Petapa", Abreviation = "Santa María Petapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20428", Name = "Santa María Quiegolani", Abreviation = "Santa María Quiegolani", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20429", Name = "Santa María Sola", Abreviation = "Santa María Sola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20430", Name = "Santa María Tataltepec", Abreviation = "Santa María Tataltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20431", Name = "Santa María Tecomavaca", Abreviation = "Santa María Tecomavaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20432", Name = "Santa María Temaxcalapa", Abreviation = "Santa María Temaxcalapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20433", Name = "Santa María Temaxcaltepec", Abreviation = "Santa María Temaxcaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20434", Name = "Santa María Teopoxco", Abreviation = "Santa María Teopoxco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20435", Name = "Santa María Tepantlali", Abreviation = "Santa María Tepantlali", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20436", Name = "Santa María Texcatitlán", Abreviation = "Santa María Texcatitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20437", Name = "Santa María Tlahuitoltepec", Abreviation = "Santa María Tlahuitoltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20438", Name = "Santa María Tlalixtac", Abreviation = "Santa María Tlalixtac", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20439", Name = "Santa María Tonameca", Abreviation = "Santa María Tonameca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20440", Name = "Santa María Totolapilla", Abreviation = "Santa María Totolapilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20441", Name = "Santa María Xadani", Abreviation = "Santa María Xadani", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20442", Name = "Santa María Yalina", Abreviation = "Santa María Yalina", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20443", Name = "Santa María Yavesía", Abreviation = "Santa María Yavesía", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20444", Name = "Santa María Yolotepec", Abreviation = "Santa María Yolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20445", Name = "Santa María Yosoyúa", Abreviation = "Santa María Yosoyúa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20446", Name = "Santa María Yucuhiti", Abreviation = "Santa María Yucuhiti", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20447", Name = "Santa María Zacatepec", Abreviation = "Santa María Zacatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20448", Name = "Santa María Zaniza", Abreviation = "Santa María Zaniza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20449", Name = "Santa María Zoquitlán", Abreviation = "Santa María Zoquitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20450", Name = "Santiago Amoltepec", Abreviation = "Santiago Amoltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20451", Name = "Santiago Apoala", Abreviation = "Santiago Apoala", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20452", Name = "Santiago Apóstol", Abreviation = "Santiago Apóstol", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20453", Name = "Santiago Astata", Abreviation = "Santiago Astata", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20454", Name = "Santiago Atitlán", Abreviation = "Santiago Atitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20455", Name = "Santiago Ayuquililla", Abreviation = "Santiago Ayuquililla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20456", Name = "Santiago Cacaloxtepec", Abreviation = "Santiago Cacaloxtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20457", Name = "Santiago Camotlán", Abreviation = "Santiago Camotlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20458", Name = "Santiago Comaltepec", Abreviation = "Santiago Comaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20459", Name = "Santiago Chazumba", Abreviation = "Santiago Chazumba", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20460", Name = "Santiago Choápam", Abreviation = "Santiago Choápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20461", Name = "Santiago del Río", Abreviation = "Santiago del Río", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20462", Name = "Santiago Huajolotitlán", Abreviation = "Santiago Huajolotitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20463", Name = "Santiago Huauclilla", Abreviation = "Santiago Huauclilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20464", Name = "Santiago Ihuitlán Plumas", Abreviation = "Santiago Ihuitlán Plumas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20465", Name = "Santiago Ixcuintepec", Abreviation = "Santiago Ixcuintepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20466", Name = "Santiago Ixtayutla", Abreviation = "Santiago Ixtayutla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20467", Name = "Santiago Jamiltepec", Abreviation = "Santiago Jamiltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20468", Name = "Santiago Jocotepec", Abreviation = "Santiago Jocotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20469", Name = "Santiago Juxtlahuaca", Abreviation = "Santiago Juxtlahuaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20470", Name = "Santiago Lachiguiri", Abreviation = "Santiago Lachiguiri", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20471", Name = "Santiago Lalopa", Abreviation = "Santiago Lalopa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20472", Name = "Santiago Laollaga", Abreviation = "Santiago Laollaga", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20473", Name = "Santiago Laxopa", Abreviation = "Santiago Laxopa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20474", Name = "Santiago Llano Grande", Abreviation = "Santiago Llano Grande", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20475", Name = "Santiago Matatlán", Abreviation = "Santiago Matatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20476", Name = "Santiago Miltepec", Abreviation = "Santiago Miltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20477", Name = "Santiago Minas", Abreviation = "Santiago Minas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20478", Name = "Santiago Nacaltepec", Abreviation = "Santiago Nacaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20479", Name = "Santiago Nejapilla", Abreviation = "Santiago Nejapilla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20480", Name = "Santiago Nundiche", Abreviation = "Santiago Nundiche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20481", Name = "Santiago Nuyoó", Abreviation = "Santiago Nuyoó", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20482", Name = "Santiago Pinotepa Nacional", Abreviation = "Santiago Pinotepa Nacional", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20483", Name = "Santiago Suchilquitongo", Abreviation = "Santiago Suchilquitongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20484", Name = "Santiago Tamazola", Abreviation = "Santiago Tamazola", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20485", Name = "Santiago Tapextla", Abreviation = "Santiago Tapextla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20486", Name = "Villa Tejúpam de la Unión", Abreviation = "Villa Tejúpam de la Unión", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20487", Name = "Santiago Tenango", Abreviation = "Santiago Tenango", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20488", Name = "Santiago Tepetlapa", Abreviation = "Santiago Tepetlapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20489", Name = "Santiago Tetepec", Abreviation = "Santiago Tetepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20490", Name = "Santiago Texcalcingo", Abreviation = "Santiago Texcalcingo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20491", Name = "Santiago Textitlán", Abreviation = "Santiago Textitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20492", Name = "Santiago Tilantongo", Abreviation = "Santiago Tilantongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20493", Name = "Santiago Tillo", Abreviation = "Santiago Tillo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20494", Name = "Santiago Tlazoyaltepec", Abreviation = "Santiago Tlazoyaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20495", Name = "Santiago Xanica", Abreviation = "Santiago Xanica", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20496", Name = "Santiago Xiacuí", Abreviation = "Santiago Xiacuí", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20497", Name = "Santiago Yaitepec", Abreviation = "Santiago Yaitepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20498", Name = "Santiago Yaveo", Abreviation = "Santiago Yaveo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20499", Name = "Santiago Yolomécatl", Abreviation = "Santiago Yolomécatl", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20500", Name = "Santiago Yosondúa", Abreviation = "Santiago Yosondúa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20501", Name = "Santiago Yucuyachi", Abreviation = "Santiago Yucuyachi", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20502", Name = "Santiago Zacatepec", Abreviation = "Santiago Zacatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20503", Name = "Santiago Zoochila", Abreviation = "Santiago Zoochila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20504", Name = "Nuevo Zoquiápam", Abreviation = "Nuevo Zoquiápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20505", Name = "Santo Domingo Ingenio", Abreviation = "Santo Domingo Ingenio", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20506", Name = "Santo Domingo Albarradas", Abreviation = "Santo Domingo Albarradas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20507", Name = "Santo Domingo Armenta", Abreviation = "Santo Domingo Armenta", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20508", Name = "Santo Domingo Chihuitán", Abreviation = "Santo Domingo Chihuitán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20509", Name = "Santo Domingo de Morelos", Abreviation = "Santo Domingo de Morelos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20510", Name = "Santo Domingo Ixcatlán", Abreviation = "Santo Domingo Ixcatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20511", Name = "Santo Domingo Nuxaá", Abreviation = "Santo Domingo Nuxaá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20512", Name = "Santo Domingo Ozolotepec", Abreviation = "Santo Domingo Ozolotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20513", Name = "Santo Domingo Petapa", Abreviation = "Santo Domingo Petapa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20514", Name = "Santo Domingo Roayaga", Abreviation = "Santo Domingo Roayaga", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20515", Name = "Santo Domingo Tehuantepec", Abreviation = "Santo Domingo Tehuantepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20516", Name = "Santo Domingo Teojomulco", Abreviation = "Santo Domingo Teojomulco", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20517", Name = "Santo Domingo Tepuxtepec", Abreviation = "Santo Domingo Tepuxtepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20518", Name = "Santo Domingo Tlatayápam", Abreviation = "Santo Domingo Tlatayápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20519", Name = "Santo Domingo Tomaltepec", Abreviation = "Santo Domingo Tomaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20520", Name = "Santo Domingo Tonalá", Abreviation = "Santo Domingo Tonalá", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20521", Name = "Santo Domingo Tonaltepec", Abreviation = "Santo Domingo Tonaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20522", Name = "Santo Domingo Xagacía", Abreviation = "Santo Domingo Xagacía", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20523", Name = "Santo Domingo Yanhuitlán", Abreviation = "Santo Domingo Yanhuitlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20524", Name = "Santo Domingo Yodohino", Abreviation = "Santo Domingo Yodohino", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20525", Name = "Santo Domingo Zanatepec", Abreviation = "Santo Domingo Zanatepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20526", Name = "Santos Reyes Nopala", Abreviation = "Santos Reyes Nopala", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20527", Name = "Santos Reyes Pápalo", Abreviation = "Santos Reyes Pápalo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20528", Name = "Santos Reyes Tepejillo", Abreviation = "Santos Reyes Tepejillo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20529", Name = "Santos Reyes Yucuná", Abreviation = "Santos Reyes Yucuná", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20530", Name = "Santo Tomás Jalieza", Abreviation = "Santo Tomás Jalieza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20531", Name = "Santo Tomás Mazaltepec", Abreviation = "Santo Tomás Mazaltepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20532", Name = "Santo Tomás Ocotepec", Abreviation = "Santo Tomás Ocotepec", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20533", Name = "Santo Tomás Tamazulapan", Abreviation = "Santo Tomás Tamazulapan", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20534", Name = "San Vicente Coatlán", Abreviation = "San Vicente Coatlán", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20535", Name = "San Vicente Lachixío", Abreviation = "San Vicente Lachixío", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20536", Name = "San Vicente Nuñú", Abreviation = "San Vicente Nuñú", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20537", Name = "Silacayoápam", Abreviation = "Silacayoápam", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20538", Name = "Sitio de Xitlapehua", Abreviation = "Sitio de Xitlapehua", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20539", Name = "Soledad Etla", Abreviation = "Soledad Etla", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20540", Name = "Villa de Tamazulápam del Progreso", Abreviation = "Villa de Tamazulápam del Progreso", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20541", Name = "Tanetze de Zaragoza", Abreviation = "Tanetze de Zaragoza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20542", Name = "Taniche", Abreviation = "Taniche", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20543", Name = "Tataltepec de Valdés", Abreviation = "Tataltepec de Valdés", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20544", Name = "Teococuilco de Marcos Pérez", Abreviation = "Teococuilco de Marcos Pérez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20545", Name = "Teotitlán de Flores Magón", Abreviation = "Teotitlán de Flores Magón", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20546", Name = "Teotitlán del Valle", Abreviation = "Teotitlán del Valle", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20547", Name = "Teotongo", Abreviation = "Teotongo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20548", Name = "Tepelmeme Villa de Morelos", Abreviation = "Tepelmeme Villa de Morelos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20549", Name = "Heroica Villa Tezoatlán de Segura y Luna, Cuna de la Independencia de Oaxaca", Abreviation = "Heroica Villa Tezoatlán de Segura y Luna, Cuna de la Independencia de Oaxaca", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20550", Name = "San Jerónimo Tlacochahuaya", Abreviation = "San Jerónimo Tlacochahuaya", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20551", Name = "Tlacolula de Matamoros", Abreviation = "Tlacolula de Matamoros", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20552", Name = "Tlacotepec Plumas", Abreviation = "Tlacotepec Plumas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20553", Name = "Tlalixtac de Cabrera", Abreviation = "Tlalixtac de Cabrera", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20554", Name = "Totontepec Villa de Morelos", Abreviation = "Totontepec Villa de Morelos", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20555", Name = "Trinidad Zaachila", Abreviation = "Trinidad Zaachila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20556", Name = "La Trinidad Vista Hermosa", Abreviation = "La Trinidad Vista Hermosa", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20557", Name = "Unión Hidalgo", Abreviation = "Unión Hidalgo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20558", Name = "Valerio Trujano", Abreviation = "Valerio Trujano", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20559", Name = "San Juan Bautista Valle Nacional", Abreviation = "San Juan Bautista Valle Nacional", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20560", Name = "Villa Díaz Ordaz", Abreviation = "Villa Díaz Ordaz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20561", Name = "Yaxe", Abreviation = "Yaxe", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20562", Name = "Magdalena Yodocono de Porfirio Díaz", Abreviation = "Magdalena Yodocono de Porfirio Díaz", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20563", Name = "Yogana", Abreviation = "Yogana", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20564", Name = "Yutanduchi de Guerrero", Abreviation = "Yutanduchi de Guerrero", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20565", Name = "Villa de Zaachila", Abreviation = "Villa de Zaachila", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20566", Name = "San Mateo Yucutindoo", Abreviation = "San Mateo Yucutindoo", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20567", Name = "Zapotitlán Lagunas", Abreviation = "Zapotitlán Lagunas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20568", Name = "Zapotitlán Palmas", Abreviation = "Zapotitlán Palmas", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20569", Name = "Santa Inés de Zaragoza", Abreviation = "Santa Inés de Zaragoza", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "20570", Name = "Zimatlán de Álvarez", Abreviation = "Zimatlán de Álvarez", IsActive = true, StateId = "20" },
                    new Domain.City() { Id = "21001", Name = "Acajete", Abreviation = "Acajete", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21002", Name = "Acateno", Abreviation = "Acateno", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21003", Name = "Acatlán", Abreviation = "Acatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21004", Name = "Acatzingo", Abreviation = "Acatzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21005", Name = "Acteopan", Abreviation = "Acteopan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21006", Name = "Ahuacatlán", Abreviation = "Ahuacatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21007", Name = "Ahuatlán", Abreviation = "Ahuatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21008", Name = "Ahuazotepec", Abreviation = "Ahuazotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21009", Name = "Ahuehuetitla", Abreviation = "Ahuehuetitla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21010", Name = "Ajalpan", Abreviation = "Ajalpan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21011", Name = "Albino Zertuche", Abreviation = "Albino Zertuche", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21012", Name = "Aljojuca", Abreviation = "Aljojuca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21013", Name = "Altepexi", Abreviation = "Altepexi", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21014", Name = "Amixtlán", Abreviation = "Amixtlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21015", Name = "Amozoc", Abreviation = "Amozoc", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21016", Name = "Aquixtla", Abreviation = "Aquixtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21017", Name = "Atempan", Abreviation = "Atempan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21018", Name = "Atexcal", Abreviation = "Atexcal", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21019", Name = "Atlixco", Abreviation = "Atlixco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21020", Name = "Atoyatempan", Abreviation = "Atoyatempan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21021", Name = "Atzala", Abreviation = "Atzala", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21022", Name = "Atzitzihuacán", Abreviation = "Atzitzihuacán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21023", Name = "Atzitzintla", Abreviation = "Atzitzintla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21024", Name = "Axutla", Abreviation = "Axutla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21025", Name = "Ayotoxco de Guerrero", Abreviation = "Ayotoxco de Guerrero", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21026", Name = "Calpan", Abreviation = "Calpan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21027", Name = "Caltepec", Abreviation = "Caltepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21028", Name = "Camocuautla", Abreviation = "Camocuautla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21029", Name = "Caxhuacan", Abreviation = "Caxhuacan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21030", Name = "Coatepec", Abreviation = "Coatepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21031", Name = "Coatzingo", Abreviation = "Coatzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21032", Name = "Cohetzala", Abreviation = "Cohetzala", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21033", Name = "Cohuecan", Abreviation = "Cohuecan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21034", Name = "Coronango", Abreviation = "Coronango", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21035", Name = "Coxcatlán", Abreviation = "Coxcatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21036", Name = "Coyomeapan", Abreviation = "Coyomeapan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21037", Name = "Coyotepec", Abreviation = "Coyotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21038", Name = "Cuapiaxtla de Madero", Abreviation = "Cuapiaxtla de Madero", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21039", Name = "Cuautempan", Abreviation = "Cuautempan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21040", Name = "Cuautinchán", Abreviation = "Cuautinchán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21041", Name = "Cuautlancingo", Abreviation = "Cuautlancingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21042", Name = "Cuayuca de Andrade", Abreviation = "Cuayuca de Andrade", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21043", Name = "Cuetzalan del Progreso", Abreviation = "Cuetzalan del Progreso", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21044", Name = "Cuyoaco", Abreviation = "Cuyoaco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21045", Name = "Chalchicomula de Sesma", Abreviation = "Chalchicomula de Sesma", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21046", Name = "Chapulco", Abreviation = "Chapulco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21047", Name = "Chiautla", Abreviation = "Chiautla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21048", Name = "Chiautzingo", Abreviation = "Chiautzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21049", Name = "Chiconcuautla", Abreviation = "Chiconcuautla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21050", Name = "Chichiquila", Abreviation = "Chichiquila", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21051", Name = "Chietla", Abreviation = "Chietla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21052", Name = "Chigmecatitlán", Abreviation = "Chigmecatitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21053", Name = "Chignahuapan", Abreviation = "Chignahuapan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21054", Name = "Chignautla", Abreviation = "Chignautla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21055", Name = "Chila", Abreviation = "Chila", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21056", Name = "Chila de la Sal", Abreviation = "Chila de la Sal", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21057", Name = "Honey", Abreviation = "Honey", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21058", Name = "Chilchotla", Abreviation = "Chilchotla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21059", Name = "Chinantla", Abreviation = "Chinantla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21060", Name = "Domingo Arenas", Abreviation = "Domingo Arenas", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21061", Name = "Eloxochitlán", Abreviation = "Eloxochitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21062", Name = "Epatlán", Abreviation = "Epatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21063", Name = "Esperanza", Abreviation = "Esperanza", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21064", Name = "Francisco Z. Mena", Abreviation = "Francisco Z. Mena", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21065", Name = "General Felipe Ángeles", Abreviation = "General Felipe Ángeles", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21066", Name = "Guadalupe", Abreviation = "Guadalupe", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21067", Name = "Guadalupe Victoria", Abreviation = "Guadalupe Victoria", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21068", Name = "Hermenegildo Galeana", Abreviation = "Hermenegildo Galeana", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21069", Name = "Huaquechula", Abreviation = "Huaquechula", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21070", Name = "Huatlatlauca", Abreviation = "Huatlatlauca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21071", Name = "Huauchinango", Abreviation = "Huauchinango", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21072", Name = "Huehuetla", Abreviation = "Huehuetla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21073", Name = "Huehuetlán el Chico", Abreviation = "Huehuetlán el Chico", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21074", Name = "Huejotzingo", Abreviation = "Huejotzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21075", Name = "Hueyapan", Abreviation = "Hueyapan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21076", Name = "Hueytamalco", Abreviation = "Hueytamalco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21077", Name = "Hueytlalpan", Abreviation = "Hueytlalpan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21078", Name = "Huitzilan de Serdán", Abreviation = "Huitzilan de Serdán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21079", Name = "Huitziltepec", Abreviation = "Huitziltepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21080", Name = "Atlequizayan", Abreviation = "Atlequizayan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21081", Name = "Ixcamilpa de Guerrero", Abreviation = "Ixcamilpa de Guerrero", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21082", Name = "Ixcaquixtla", Abreviation = "Ixcaquixtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21083", Name = "Ixtacamaxtitlán", Abreviation = "Ixtacamaxtitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21084", Name = "Ixtepec", Abreviation = "Ixtepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21085", Name = "Izúcar de Matamoros", Abreviation = "Izúcar de Matamoros", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21086", Name = "Jalpan", Abreviation = "Jalpan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21087", Name = "Jolalpan", Abreviation = "Jolalpan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21088", Name = "Jonotla", Abreviation = "Jonotla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21089", Name = "Jopala", Abreviation = "Jopala", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21090", Name = "Juan C. Bonilla", Abreviation = "Juan C. Bonilla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21091", Name = "Juan Galindo", Abreviation = "Juan Galindo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21092", Name = "Juan N. Méndez", Abreviation = "Juan N. Méndez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21093", Name = "Lafragua", Abreviation = "Lafragua", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21094", Name = "Libres", Abreviation = "Libres", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21095", Name = "La Magdalena Tlatlauquitepec", Abreviation = "La Magdalena Tlatlauquitepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21096", Name = "Mazapiltepec de Juárez", Abreviation = "Mazapiltepec de Juárez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21097", Name = "Mixtla", Abreviation = "Mixtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21098", Name = "Molcaxac", Abreviation = "Molcaxac", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21099", Name = "Cañada Morelos", Abreviation = "Cañada Morelos", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21100", Name = "Naupan", Abreviation = "Naupan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21101", Name = "Nauzontla", Abreviation = "Nauzontla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21102", Name = "Nealtican", Abreviation = "Nealtican", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21103", Name = "Nicolás Bravo", Abreviation = "Nicolás Bravo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21104", Name = "Nopalucan", Abreviation = "Nopalucan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21105", Name = "Ocotepec", Abreviation = "Ocotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21106", Name = "Ocoyucan", Abreviation = "Ocoyucan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21107", Name = "Olintla", Abreviation = "Olintla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21108", Name = "Oriental", Abreviation = "Oriental", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21109", Name = "Pahuatlán", Abreviation = "Pahuatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21110", Name = "Palmar de Bravo", Abreviation = "Palmar de Bravo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21111", Name = "Pantepec", Abreviation = "Pantepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21112", Name = "Petlalcingo", Abreviation = "Petlalcingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21113", Name = "Piaxtla", Abreviation = "Piaxtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21114", Name = "Puebla", Abreviation = "Puebla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21115", Name = "Quecholac", Abreviation = "Quecholac", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21116", Name = "Quimixtlán", Abreviation = "Quimixtlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21117", Name = "Rafael Lara Grajales", Abreviation = "Rafael Lara Grajales", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21118", Name = "Los Reyes de Juárez", Abreviation = "Los Reyes de Juárez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21119", Name = "San Andrés Cholula", Abreviation = "San Andrés Cholula", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21120", Name = "San Antonio Cañada", Abreviation = "San Antonio Cañada", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21121", Name = "San Diego la Mesa Tochimiltzingo", Abreviation = "San Diego la Mesa Tochimiltzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21122", Name = "San Felipe Teotlalcingo", Abreviation = "San Felipe Teotlalcingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21123", Name = "San Felipe Tepatlán", Abreviation = "San Felipe Tepatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21124", Name = "San Gabriel Chilac", Abreviation = "San Gabriel Chilac", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21125", Name = "San Gregorio Atzompa", Abreviation = "San Gregorio Atzompa", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21126", Name = "San Jerónimo Tecuanipan", Abreviation = "San Jerónimo Tecuanipan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21127", Name = "San Jerónimo Xayacatlán", Abreviation = "San Jerónimo Xayacatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21128", Name = "San José Chiapa", Abreviation = "San José Chiapa", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21129", Name = "San José Miahuatlán", Abreviation = "San José Miahuatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21130", Name = "San Juan Atenco", Abreviation = "San Juan Atenco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21131", Name = "San Juan Atzompa", Abreviation = "San Juan Atzompa", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21132", Name = "San Martín Texmelucan", Abreviation = "San Martín Texmelucan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21133", Name = "San Martín Totoltepec", Abreviation = "San Martín Totoltepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21134", Name = "San Matías Tlalancaleca", Abreviation = "San Matías Tlalancaleca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21135", Name = "San Miguel Ixitlán", Abreviation = "San Miguel Ixitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21136", Name = "San Miguel Xoxtla", Abreviation = "San Miguel Xoxtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21137", Name = "San Nicolás Buenos Aires", Abreviation = "San Nicolás Buenos Aires", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21138", Name = "San Nicolás de los Ranchos", Abreviation = "San Nicolás de los Ranchos", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21139", Name = "San Pablo Anicano", Abreviation = "San Pablo Anicano", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21140", Name = "San Pedro Cholula", Abreviation = "San Pedro Cholula", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21141", Name = "San Pedro Yeloixtlahuaca", Abreviation = "San Pedro Yeloixtlahuaca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21142", Name = "San Salvador el Seco", Abreviation = "San Salvador el Seco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21143", Name = "San Salvador el Verde", Abreviation = "San Salvador el Verde", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21144", Name = "San Salvador Huixcolotla", Abreviation = "San Salvador Huixcolotla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21145", Name = "San Sebastián Tlacotepec", Abreviation = "San Sebastián Tlacotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21146", Name = "Santa Catarina Tlaltempan", Abreviation = "Santa Catarina Tlaltempan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21147", Name = "Santa Inés Ahuatempan", Abreviation = "Santa Inés Ahuatempan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21148", Name = "Santa Isabel Cholula", Abreviation = "Santa Isabel Cholula", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21149", Name = "Santiago Miahuatlán", Abreviation = "Santiago Miahuatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21150", Name = "Huehuetlán el Grande", Abreviation = "Huehuetlán el Grande", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21151", Name = "Santo Tomás Hueyotlipan", Abreviation = "Santo Tomás Hueyotlipan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21152", Name = "Soltepec", Abreviation = "Soltepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21153", Name = "Tecali de Herrera", Abreviation = "Tecali de Herrera", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21154", Name = "Tecamachalco", Abreviation = "Tecamachalco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21155", Name = "Tecomatlán", Abreviation = "Tecomatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21156", Name = "Tehuacán", Abreviation = "Tehuacán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21157", Name = "Tehuitzingo", Abreviation = "Tehuitzingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21158", Name = "Tenampulco", Abreviation = "Tenampulco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21159", Name = "Teopantlán", Abreviation = "Teopantlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21160", Name = "Teotlalco", Abreviation = "Teotlalco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21161", Name = "Tepanco de López", Abreviation = "Tepanco de López", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21162", Name = "Tepango de Rodríguez", Abreviation = "Tepango de Rodríguez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21163", Name = "Tepatlaxco de Hidalgo", Abreviation = "Tepatlaxco de Hidalgo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21164", Name = "Tepeaca", Abreviation = "Tepeaca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21165", Name = "Tepemaxalco", Abreviation = "Tepemaxalco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21166", Name = "Tepeojuma", Abreviation = "Tepeojuma", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21167", Name = "Tepetzintla", Abreviation = "Tepetzintla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21168", Name = "Tepexco", Abreviation = "Tepexco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21169", Name = "Tepexi de Rodríguez", Abreviation = "Tepexi de Rodríguez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21170", Name = "Tepeyahualco", Abreviation = "Tepeyahualco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21171", Name = "Tepeyahualco de Cuauhtémoc", Abreviation = "Tepeyahualco de Cuauhtémoc", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21172", Name = "Tetela de Ocampo", Abreviation = "Tetela de Ocampo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21173", Name = "Teteles de Avila Castillo", Abreviation = "Teteles de Avila Castillo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21174", Name = "Teziutlán", Abreviation = "Teziutlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21175", Name = "Tianguismanalco", Abreviation = "Tianguismanalco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21176", Name = "Tilapa", Abreviation = "Tilapa", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21177", Name = "Tlacotepec de Benito Juárez", Abreviation = "Tlacotepec de Benito Juárez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21178", Name = "Tlacuilotepec", Abreviation = "Tlacuilotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21179", Name = "Tlachichuca", Abreviation = "Tlachichuca", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21180", Name = "Tlahuapan", Abreviation = "Tlahuapan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21181", Name = "Tlaltenango", Abreviation = "Tlaltenango", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21182", Name = "Tlanepantla", Abreviation = "Tlanepantla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21183", Name = "Tlaola", Abreviation = "Tlaola", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21184", Name = "Tlapacoya", Abreviation = "Tlapacoya", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21185", Name = "Tlapanalá", Abreviation = "Tlapanalá", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21186", Name = "Tlatlauquitepec", Abreviation = "Tlatlauquitepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21187", Name = "Tlaxco", Abreviation = "Tlaxco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21188", Name = "Tochimilco", Abreviation = "Tochimilco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21189", Name = "Tochtepec", Abreviation = "Tochtepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21190", Name = "Totoltepec de Guerrero", Abreviation = "Totoltepec de Guerrero", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21191", Name = "Tulcingo", Abreviation = "Tulcingo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21192", Name = "Tuzamapan de Galeana", Abreviation = "Tuzamapan de Galeana", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21193", Name = "Tzicatlacoyan", Abreviation = "Tzicatlacoyan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21194", Name = "Venustiano Carranza", Abreviation = "Venustiano Carranza", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21195", Name = "Vicente Guerrero", Abreviation = "Vicente Guerrero", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21196", Name = "Xayacatlán de Bravo", Abreviation = "Xayacatlán de Bravo", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21197", Name = "Xicotepec", Abreviation = "Xicotepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21198", Name = "Xicotlán", Abreviation = "Xicotlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21199", Name = "Xiutetelco", Abreviation = "Xiutetelco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21200", Name = "Xochiapulco", Abreviation = "Xochiapulco", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21201", Name = "Xochiltepec", Abreviation = "Xochiltepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21202", Name = "Xochitlán de Vicente Suárez", Abreviation = "Xochitlán de Vicente Suárez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21203", Name = "Xochitlán Todos Santos", Abreviation = "Xochitlán Todos Santos", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21204", Name = "Yaonáhuac", Abreviation = "Yaonáhuac", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21205", Name = "Yehualtepec", Abreviation = "Yehualtepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21206", Name = "Zacapala", Abreviation = "Zacapala", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21207", Name = "Zacapoaxtla", Abreviation = "Zacapoaxtla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21208", Name = "Zacatlán", Abreviation = "Zacatlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21209", Name = "Zapotitlán", Abreviation = "Zapotitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21210", Name = "Zapotitlán de Méndez", Abreviation = "Zapotitlán de Méndez", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21211", Name = "Zaragoza", Abreviation = "Zaragoza", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21212", Name = "Zautla", Abreviation = "Zautla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21213", Name = "Zihuateutla", Abreviation = "Zihuateutla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21214", Name = "Zinacatepec", Abreviation = "Zinacatepec", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21215", Name = "Zongozotla", Abreviation = "Zongozotla", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21216", Name = "Zoquiapan", Abreviation = "Zoquiapan", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "21217", Name = "Zoquitlán", Abreviation = "Zoquitlán", IsActive = true, StateId = "21" },
                    new Domain.City() { Id = "22001", Name = "Amealco de Bonfil", Abreviation = "Amealco de Bonfil", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22002", Name = "Pinal de Amoles", Abreviation = "Pinal de Amoles", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22003", Name = "Arroyo Seco", Abreviation = "Arroyo Seco", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22004", Name = "Cadereyta de Montes", Abreviation = "Cadereyta de Montes", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22005", Name = "Colón", Abreviation = "Colón", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22006", Name = "Corregidora", Abreviation = "Corregidora", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22007", Name = "Ezequiel Montes", Abreviation = "Ezequiel Montes", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22008", Name = "Huimilpan", Abreviation = "Huimilpan", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22009", Name = "Jalpan de Serra", Abreviation = "Jalpan de Serra", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22010", Name = "Landa de Matamoros", Abreviation = "Landa de Matamoros", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22011", Name = "El Marqués", Abreviation = "El Marqués", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22012", Name = "Pedro Escobedo", Abreviation = "Pedro Escobedo", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22013", Name = "Peñamiller", Abreviation = "Peñamiller", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22014", Name = "Querétaro", Abreviation = "Querétaro", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22015", Name = "San Joaquín", Abreviation = "San Joaquín", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22016", Name = "San Juan del Río", Abreviation = "San Juan del Río", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22017", Name = "Tequisquiapan", Abreviation = "Tequisquiapan", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "22018", Name = "Tolimán", Abreviation = "Tolimán", IsActive = true, StateId = "22" },
                    new Domain.City() { Id = "23001", Name = "Cozumel", Abreviation = "Cozumel", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23002", Name = "Felipe Carrillo Puerto", Abreviation = "Felipe Carrillo Puerto", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23003", Name = "Isla Mujeres", Abreviation = "Isla Mujeres", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23004", Name = "Othón P. Blanco", Abreviation = "Othón P. Blanco", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23005", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23006", Name = "José María Morelos", Abreviation = "José María Morelos", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23007", Name = "Lázaro Cárdenas", Abreviation = "Lázaro Cárdenas", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23008", Name = "Solidaridad", Abreviation = "Solidaridad", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23009", Name = "Tulum", Abreviation = "Tulum", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23010", Name = "Bacalar", Abreviation = "Bacalar", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "23011", Name = "Puerto Morelos", Abreviation = "Puerto Morelos", IsActive = true, StateId = "23" },
                    new Domain.City() { Id = "24001", Name = "Ahualulco", Abreviation = "Ahualulco", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24002", Name = "Alaquines", Abreviation = "Alaquines", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24003", Name = "Aquismón", Abreviation = "Aquismón", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24004", Name = "Armadillo de los Infante", Abreviation = "Armadillo de los Infante", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24005", Name = "Cárdenas", Abreviation = "Cárdenas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24006", Name = "Catorce", Abreviation = "Catorce", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24007", Name = "Cedral", Abreviation = "Cedral", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24008", Name = "Cerritos", Abreviation = "Cerritos", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24009", Name = "Cerro de San Pedro", Abreviation = "Cerro de San Pedro", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24010", Name = "Ciudad del Maíz", Abreviation = "Ciudad del Maíz", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24011", Name = "Ciudad Fernández", Abreviation = "Ciudad Fernández", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24012", Name = "Tancanhuitz", Abreviation = "Tancanhuitz", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24013", Name = "Ciudad Valles", Abreviation = "Ciudad Valles", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24014", Name = "Coxcatlán", Abreviation = "Coxcatlán", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24015", Name = "Charcas", Abreviation = "Charcas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24016", Name = "Ebano", Abreviation = "Ebano", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24017", Name = "Guadalcázar", Abreviation = "Guadalcázar", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24018", Name = "Huehuetlán", Abreviation = "Huehuetlán", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24019", Name = "Lagunillas", Abreviation = "Lagunillas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24020", Name = "Matehuala", Abreviation = "Matehuala", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24021", Name = "Mexquitic de Carmona", Abreviation = "Mexquitic de Carmona", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24022", Name = "Moctezuma", Abreviation = "Moctezuma", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24023", Name = "Rayón", Abreviation = "Rayón", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24024", Name = "Rioverde", Abreviation = "Rioverde", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24025", Name = "Salinas", Abreviation = "Salinas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24026", Name = "San Antonio", Abreviation = "San Antonio", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24027", Name = "San Ciro de Acosta", Abreviation = "San Ciro de Acosta", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24028", Name = "San Luis Potosí", Abreviation = "San Luis Potosí", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24029", Name = "San Martín Chalchicuautla", Abreviation = "San Martín Chalchicuautla", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24030", Name = "San Nicolás Tolentino", Abreviation = "San Nicolás Tolentino", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24031", Name = "Santa Catarina", Abreviation = "Santa Catarina", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24032", Name = "Santa María del Río", Abreviation = "Santa María del Río", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24033", Name = "Santo Domingo", Abreviation = "Santo Domingo", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24034", Name = "San Vicente Tancuayalab", Abreviation = "San Vicente Tancuayalab", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24035", Name = "Soledad de Graciano Sánchez", Abreviation = "Soledad de Graciano Sánchez", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24036", Name = "Tamasopo", Abreviation = "Tamasopo", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24037", Name = "Tamazunchale", Abreviation = "Tamazunchale", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24038", Name = "Tampacán", Abreviation = "Tampacán", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24039", Name = "Tampamolón Corona", Abreviation = "Tampamolón Corona", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24040", Name = "Tamuín", Abreviation = "Tamuín", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24041", Name = "Tanlajás", Abreviation = "Tanlajás", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24042", Name = "Tanquián de Escobedo", Abreviation = "Tanquián de Escobedo", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24043", Name = "Tierra Nueva", Abreviation = "Tierra Nueva", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24044", Name = "Vanegas", Abreviation = "Vanegas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24045", Name = "Venado", Abreviation = "Venado", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24046", Name = "Villa de Arriaga", Abreviation = "Villa de Arriaga", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24047", Name = "Villa de Guadalupe", Abreviation = "Villa de Guadalupe", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24048", Name = "Villa de la Paz", Abreviation = "Villa de la Paz", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24049", Name = "Villa de Ramos", Abreviation = "Villa de Ramos", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24050", Name = "Villa de Reyes", Abreviation = "Villa de Reyes", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24051", Name = "Villa Hidalgo", Abreviation = "Villa Hidalgo", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24052", Name = "Villa Juárez", Abreviation = "Villa Juárez", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24053", Name = "Axtla de Terrazas", Abreviation = "Axtla de Terrazas", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24054", Name = "Xilitla", Abreviation = "Xilitla", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24055", Name = "Zaragoza", Abreviation = "Zaragoza", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24056", Name = "Villa de Arista", Abreviation = "Villa de Arista", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24057", Name = "Matlapa", Abreviation = "Matlapa", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "24058", Name = "El Naranjo", Abreviation = "El Naranjo", IsActive = true, StateId = "24" },
                    new Domain.City() { Id = "25001", Name = "Ahome", Abreviation = "Ahome", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25002", Name = "Angostura", Abreviation = "Angostura", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25003", Name = "Badiraguato", Abreviation = "Badiraguato", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25004", Name = "Concordia", Abreviation = "Concordia", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25005", Name = "Cosalá", Abreviation = "Cosalá", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25006", Name = "Culiacán", Abreviation = "Culiacán", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25007", Name = "Choix", Abreviation = "Choix", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25008", Name = "Elota", Abreviation = "Elota", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25009", Name = "Escuinapa", Abreviation = "Escuinapa", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25010", Name = "El Fuerte", Abreviation = "El Fuerte", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25011", Name = "Guasave", Abreviation = "Guasave", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25012", Name = "Mazatlán", Abreviation = "Mazatlán", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25013", Name = "Mocorito", Abreviation = "Mocorito", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25014", Name = "Rosario", Abreviation = "Rosario", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25015", Name = "Salvador Alvarado", Abreviation = "Salvador Alvarado", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25016", Name = "San Ignacio", Abreviation = "San Ignacio", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25017", Name = "Sinaloa", Abreviation = "Sinaloa", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "25018", Name = "Navolato", Abreviation = "Navolato", IsActive = true, StateId = "25" },
                    new Domain.City() { Id = "26001", Name = "Aconchi", Abreviation = "Aconchi", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26002", Name = "Agua Prieta", Abreviation = "Agua Prieta", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26003", Name = "Alamos", Abreviation = "Alamos", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26004", Name = "Altar", Abreviation = "Altar", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26005", Name = "Arivechi", Abreviation = "Arivechi", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26006", Name = "Arizpe", Abreviation = "Arizpe", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26007", Name = "Atil", Abreviation = "Atil", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26008", Name = "Bacadéhuachi", Abreviation = "Bacadéhuachi", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26009", Name = "Bacanora", Abreviation = "Bacanora", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26010", Name = "Bacerac", Abreviation = "Bacerac", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26011", Name = "Bacoachi", Abreviation = "Bacoachi", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26012", Name = "Bácum", Abreviation = "Bácum", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26013", Name = "Banámichi", Abreviation = "Banámichi", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26014", Name = "Baviácora", Abreviation = "Baviácora", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26015", Name = "Bavispe", Abreviation = "Bavispe", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26016", Name = "Benjamín Hill", Abreviation = "Benjamín Hill", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26017", Name = "Caborca", Abreviation = "Caborca", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26018", Name = "Cajeme", Abreviation = "Cajeme", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26019", Name = "Cananea", Abreviation = "Cananea", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26020", Name = "Carbó", Abreviation = "Carbó", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26021", Name = "La Colorada", Abreviation = "La Colorada", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26022", Name = "Cucurpe", Abreviation = "Cucurpe", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26023", Name = "Cumpas", Abreviation = "Cumpas", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26024", Name = "Divisaderos", Abreviation = "Divisaderos", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26025", Name = "Empalme", Abreviation = "Empalme", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26026", Name = "Etchojoa", Abreviation = "Etchojoa", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26027", Name = "Fronteras", Abreviation = "Fronteras", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26028", Name = "Granados", Abreviation = "Granados", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26029", Name = "Guaymas", Abreviation = "Guaymas", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26030", Name = "Hermosillo", Abreviation = "Hermosillo", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26031", Name = "Huachinera", Abreviation = "Huachinera", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26032", Name = "Huásabas", Abreviation = "Huásabas", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26033", Name = "Huatabampo", Abreviation = "Huatabampo", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26034", Name = "Huépac", Abreviation = "Huépac", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26035", Name = "Imuris", Abreviation = "Imuris", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26036", Name = "Magdalena", Abreviation = "Magdalena", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26037", Name = "Mazatán", Abreviation = "Mazatán", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26038", Name = "Moctezuma", Abreviation = "Moctezuma", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26039", Name = "Naco", Abreviation = "Naco", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26040", Name = "Nácori Chico", Abreviation = "Nácori Chico", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26041", Name = "Nacozari de García", Abreviation = "Nacozari de García", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26042", Name = "Navojoa", Abreviation = "Navojoa", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26043", Name = "Nogales", Abreviation = "Nogales", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26044", Name = "Onavas", Abreviation = "Onavas", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26045", Name = "Opodepe", Abreviation = "Opodepe", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26046", Name = "Oquitoa", Abreviation = "Oquitoa", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26047", Name = "Pitiquito", Abreviation = "Pitiquito", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26048", Name = "Puerto Peñasco", Abreviation = "Puerto Peñasco", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26049", Name = "Quiriego", Abreviation = "Quiriego", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26050", Name = "Rayón", Abreviation = "Rayón", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26051", Name = "Rosario", Abreviation = "Rosario", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26052", Name = "Sahuaripa", Abreviation = "Sahuaripa", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26053", Name = "San Felipe de Jesús", Abreviation = "San Felipe de Jesús", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26054", Name = "San Javier", Abreviation = "San Javier", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26055", Name = "San Luis Río Colorado", Abreviation = "San Luis Río Colorado", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26056", Name = "San Miguel de Horcasitas", Abreviation = "San Miguel de Horcasitas", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26057", Name = "San Pedro de la Cueva", Abreviation = "San Pedro de la Cueva", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26058", Name = "Santa Ana", Abreviation = "Santa Ana", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26059", Name = "Santa Cruz", Abreviation = "Santa Cruz", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26060", Name = "Sáric", Abreviation = "Sáric", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26061", Name = "Soyopa", Abreviation = "Soyopa", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26062", Name = "Suaqui Grande", Abreviation = "Suaqui Grande", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26063", Name = "Tepache", Abreviation = "Tepache", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26064", Name = "Trincheras", Abreviation = "Trincheras", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26065", Name = "Tubutama", Abreviation = "Tubutama", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26066", Name = "Ures", Abreviation = "Ures", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26067", Name = "Villa Hidalgo", Abreviation = "Villa Hidalgo", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26068", Name = "Villa Pesqueira", Abreviation = "Villa Pesqueira", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26069", Name = "Yécora", Abreviation = "Yécora", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26070", Name = "General Plutarco Elías Calles", Abreviation = "General Plutarco Elías Calles", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26071", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "26072", Name = "San Ignacio Río Muerto", Abreviation = "San Ignacio Río Muerto", IsActive = true, StateId = "26" },
                    new Domain.City() { Id = "27001", Name = "Balancán", Abreviation = "Balancán", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27002", Name = "Cárdenas", Abreviation = "Cárdenas", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27003", Name = "Centla", Abreviation = "Centla", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27004", Name = "Centro", Abreviation = "Centro", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27005", Name = "Comalcalco", Abreviation = "Comalcalco", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27006", Name = "Cunduacán", Abreviation = "Cunduacán", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27007", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27008", Name = "Huimanguillo", Abreviation = "Huimanguillo", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27009", Name = "Jalapa", Abreviation = "Jalapa", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27010", Name = "Jalpa de Méndez", Abreviation = "Jalpa de Méndez", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27011", Name = "Jonuta", Abreviation = "Jonuta", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27012", Name = "Macuspana", Abreviation = "Macuspana", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27013", Name = "Nacajuca", Abreviation = "Nacajuca", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27014", Name = "Paraíso", Abreviation = "Paraíso", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27015", Name = "Tacotalpa", Abreviation = "Tacotalpa", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27016", Name = "Teapa", Abreviation = "Teapa", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "27017", Name = "Tenosique", Abreviation = "Tenosique", IsActive = true, StateId = "27" },
                    new Domain.City() { Id = "28001", Name = "Abasolo", Abreviation = "Abasolo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28002", Name = "Aldama", Abreviation = "Aldama", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28003", Name = "Altamira", Abreviation = "Altamira", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28004", Name = "Antiguo Morelos", Abreviation = "Antiguo Morelos", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28005", Name = "Burgos", Abreviation = "Burgos", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28006", Name = "Bustamante", Abreviation = "Bustamante", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28007", Name = "Camargo", Abreviation = "Camargo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28008", Name = "Casas", Abreviation = "Casas", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28009", Name = "Ciudad Madero", Abreviation = "Ciudad Madero", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28010", Name = "Cruillas", Abreviation = "Cruillas", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28011", Name = "Gómez Farías", Abreviation = "Gómez Farías", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28012", Name = "González", Abreviation = "González", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28013", Name = "Güémez", Abreviation = "Güémez", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28014", Name = "Guerrero", Abreviation = "Guerrero", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28015", Name = "Gustavo Díaz Ordaz", Abreviation = "Gustavo Díaz Ordaz", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28016", Name = "Hidalgo", Abreviation = "Hidalgo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28017", Name = "Jaumave", Abreviation = "Jaumave", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28018", Name = "Jiménez", Abreviation = "Jiménez", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28019", Name = "Llera", Abreviation = "Llera", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28020", Name = "Mainero", Abreviation = "Mainero", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28021", Name = "El Mante", Abreviation = "El Mante", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28022", Name = "Matamoros", Abreviation = "Matamoros", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28023", Name = "Méndez", Abreviation = "Méndez", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28024", Name = "Mier", Abreviation = "Mier", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28025", Name = "Miguel Alemán", Abreviation = "Miguel Alemán", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28026", Name = "Miquihuana", Abreviation = "Miquihuana", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28027", Name = "Nuevo Laredo", Abreviation = "Nuevo Laredo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28028", Name = "Nuevo Morelos", Abreviation = "Nuevo Morelos", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28029", Name = "Ocampo", Abreviation = "Ocampo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28030", Name = "Padilla", Abreviation = "Padilla", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28031", Name = "Palmillas", Abreviation = "Palmillas", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28032", Name = "Reynosa", Abreviation = "Reynosa", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28033", Name = "Río Bravo", Abreviation = "Río Bravo", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28034", Name = "San Carlos", Abreviation = "San Carlos", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28035", Name = "San Fernando", Abreviation = "San Fernando", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28036", Name = "San Nicolás", Abreviation = "San Nicolás", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28037", Name = "Soto la Marina", Abreviation = "Soto la Marina", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28038", Name = "Tampico", Abreviation = "Tampico", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28039", Name = "Tula", Abreviation = "Tula", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28040", Name = "Valle Hermoso", Abreviation = "Valle Hermoso", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28041", Name = "Victoria", Abreviation = "Victoria", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28042", Name = "Villagrán", Abreviation = "Villagrán", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "28043", Name = "Xicoténcatl", Abreviation = "Xicoténcatl", IsActive = true, StateId = "28" },
                    new Domain.City() { Id = "29001", Name = "Amaxac de Guerrero", Abreviation = "Amaxac de Guerrero", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29002", Name = "Apetatitlán de Antonio Carvajal", Abreviation = "Apetatitlán de Antonio Carvajal", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29003", Name = "Atlangatepec", Abreviation = "Atlangatepec", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29004", Name = "Atltzayanca", Abreviation = "Atltzayanca", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29005", Name = "Apizaco", Abreviation = "Apizaco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29006", Name = "Calpulalpan", Abreviation = "Calpulalpan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29007", Name = "El Carmen Tequexquitla", Abreviation = "El Carmen Tequexquitla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29008", Name = "Cuapiaxtla", Abreviation = "Cuapiaxtla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29009", Name = "Cuaxomulco", Abreviation = "Cuaxomulco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29010", Name = "Chiautempan", Abreviation = "Chiautempan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29011", Name = "Muñoz de Domingo Arenas", Abreviation = "Muñoz de Domingo Arenas", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29012", Name = "Españita", Abreviation = "Españita", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29013", Name = "Huamantla", Abreviation = "Huamantla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29014", Name = "Hueyotlipan", Abreviation = "Hueyotlipan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29015", Name = "Ixtacuixtla de Mariano Matamoros", Abreviation = "Ixtacuixtla de Mariano Matamoros", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29016", Name = "Ixtenco", Abreviation = "Ixtenco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29017", Name = "Mazatecochco de José María Morelos", Abreviation = "Mazatecochco de José María Morelos", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29018", Name = "Contla de Juan Cuamatzi", Abreviation = "Contla de Juan Cuamatzi", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29019", Name = "Tepetitla de Lardizábal", Abreviation = "Tepetitla de Lardizábal", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29020", Name = "Sanctórum de Lázaro Cárdenas", Abreviation = "Sanctórum de Lázaro Cárdenas", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29021", Name = "Nanacamilpa de Mariano Arista", Abreviation = "Nanacamilpa de Mariano Arista", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29022", Name = "Acuamanala de Miguel Hidalgo", Abreviation = "Acuamanala de Miguel Hidalgo", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29023", Name = "Natívitas", Abreviation = "Natívitas", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29024", Name = "Panotla", Abreviation = "Panotla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29025", Name = "San Pablo del Monte", Abreviation = "San Pablo del Monte", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29026", Name = "Santa Cruz Tlaxcala", Abreviation = "Santa Cruz Tlaxcala", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29027", Name = "Tenancingo", Abreviation = "Tenancingo", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29028", Name = "Teolocholco", Abreviation = "Teolocholco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29029", Name = "Tepeyanco", Abreviation = "Tepeyanco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29030", Name = "Terrenate", Abreviation = "Terrenate", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29031", Name = "Tetla de la Solidaridad", Abreviation = "Tetla de la Solidaridad", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29032", Name = "Tetlatlahuca", Abreviation = "Tetlatlahuca", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29033", Name = "Tlaxcala", Abreviation = "Tlaxcala", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29034", Name = "Tlaxco", Abreviation = "Tlaxco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29035", Name = "Tocatlán", Abreviation = "Tocatlán", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29036", Name = "Totolac", Abreviation = "Totolac", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29037", Name = "Ziltlaltépec de Trinidad Sánchez Santos", Abreviation = "Ziltlaltépec de Trinidad Sánchez Santos", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29038", Name = "Tzompantepec", Abreviation = "Tzompantepec", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29039", Name = "Xaloztoc", Abreviation = "Xaloztoc", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29040", Name = "Xaltocan", Abreviation = "Xaltocan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29041", Name = "Papalotla de Xicohténcatl", Abreviation = "Papalotla de Xicohténcatl", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29042", Name = "Xicohtzinco", Abreviation = "Xicohtzinco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29043", Name = "Yauhquemehcan", Abreviation = "Yauhquemehcan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29044", Name = "Zacatelco", Abreviation = "Zacatelco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29045", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29046", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29047", Name = "Lázaro Cárdenas", Abreviation = "Lázaro Cárdenas", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29048", Name = "La Magdalena Tlaltelulco", Abreviation = "La Magdalena Tlaltelulco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29049", Name = "San Damián Texóloc", Abreviation = "San Damián Texóloc", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29050", Name = "San Francisco Tetlanohcan", Abreviation = "San Francisco Tetlanohcan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29051", Name = "San Jerónimo Zacualpan", Abreviation = "San Jerónimo Zacualpan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29052", Name = "San José Teacalco", Abreviation = "San José Teacalco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29053", Name = "San Juan Huactzinco", Abreviation = "San Juan Huactzinco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29054", Name = "San Lorenzo Axocomanitla", Abreviation = "San Lorenzo Axocomanitla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29055", Name = "San Lucas Tecopilco", Abreviation = "San Lucas Tecopilco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29056", Name = "Santa Ana Nopalucan", Abreviation = "Santa Ana Nopalucan", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29057", Name = "Santa Apolonia Teacalco", Abreviation = "Santa Apolonia Teacalco", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29058", Name = "Santa Catarina Ayometla", Abreviation = "Santa Catarina Ayometla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29059", Name = "Santa Cruz Quilehtla", Abreviation = "Santa Cruz Quilehtla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "29060", Name = "Santa Isabel Xiloxoxtla", Abreviation = "Santa Isabel Xiloxoxtla", IsActive = true, StateId = "29" },
                    new Domain.City() { Id = "30001", Name = "Acajete", Abreviation = "Acajete", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30002", Name = "Acatlán", Abreviation = "Acatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30003", Name = "Acayucan", Abreviation = "Acayucan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30004", Name = "Actopan", Abreviation = "Actopan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30005", Name = "Acula", Abreviation = "Acula", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30006", Name = "Acultzingo", Abreviation = "Acultzingo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30007", Name = "Camarón de Tejeda", Abreviation = "Camarón de Tejeda", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30008", Name = "Alpatláhuac", Abreviation = "Alpatláhuac", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30009", Name = "Alto Lucero de Gutiérrez Barrios", Abreviation = "Alto Lucero de Gutiérrez Barrios", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30010", Name = "Altotonga", Abreviation = "Altotonga", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30011", Name = "Alvarado", Abreviation = "Alvarado", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30012", Name = "Amatitlán", Abreviation = "Amatitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30013", Name = "Naranjos Amatlán", Abreviation = "Naranjos Amatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30014", Name = "Amatlán de los Reyes", Abreviation = "Amatlán de los Reyes", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30015", Name = "Angel R. Cabada", Abreviation = "Angel R. Cabada", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30016", Name = "La Antigua", Abreviation = "La Antigua", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30017", Name = "Apazapan", Abreviation = "Apazapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30018", Name = "Aquila", Abreviation = "Aquila", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30019", Name = "Astacinga", Abreviation = "Astacinga", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30020", Name = "Atlahuilco", Abreviation = "Atlahuilco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30021", Name = "Atoyac", Abreviation = "Atoyac", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30022", Name = "Atzacan", Abreviation = "Atzacan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30023", Name = "Atzalan", Abreviation = "Atzalan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30024", Name = "Tlaltetela", Abreviation = "Tlaltetela", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30025", Name = "Ayahualulco", Abreviation = "Ayahualulco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30026", Name = "Banderilla", Abreviation = "Banderilla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30027", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30028", Name = "Boca del Río", Abreviation = "Boca del Río", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30029", Name = "Calcahualco", Abreviation = "Calcahualco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30030", Name = "Camerino Z. Mendoza", Abreviation = "Camerino Z. Mendoza", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30031", Name = "Carrillo Puerto", Abreviation = "Carrillo Puerto", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30032", Name = "Catemaco", Abreviation = "Catemaco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30033", Name = "Cazones de Herrera", Abreviation = "Cazones de Herrera", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30034", Name = "Cerro Azul", Abreviation = "Cerro Azul", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30035", Name = "Citlaltépetl", Abreviation = "Citlaltépetl", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30036", Name = "Coacoatzintla", Abreviation = "Coacoatzintla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30037", Name = "Coahuitlán", Abreviation = "Coahuitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30038", Name = "Coatepec", Abreviation = "Coatepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30039", Name = "Coatzacoalcos", Abreviation = "Coatzacoalcos", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30040", Name = "Coatzintla", Abreviation = "Coatzintla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30041", Name = "Coetzala", Abreviation = "Coetzala", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30042", Name = "Colipa", Abreviation = "Colipa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30043", Name = "Comapa", Abreviation = "Comapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30044", Name = "Córdoba", Abreviation = "Córdoba", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30045", Name = "Cosamaloapan de Carpio", Abreviation = "Cosamaloapan de Carpio", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30046", Name = "Cosautlán de Carvajal", Abreviation = "Cosautlán de Carvajal", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30047", Name = "Coscomatepec", Abreviation = "Coscomatepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30048", Name = "Cosoleacaque", Abreviation = "Cosoleacaque", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30049", Name = "Cotaxtla", Abreviation = "Cotaxtla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30050", Name = "Coxquihui", Abreviation = "Coxquihui", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30051", Name = "Coyutla", Abreviation = "Coyutla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30052", Name = "Cuichapa", Abreviation = "Cuichapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30053", Name = "Cuitláhuac", Abreviation = "Cuitláhuac", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30054", Name = "Chacaltianguis", Abreviation = "Chacaltianguis", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30055", Name = "Chalma", Abreviation = "Chalma", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30056", Name = "Chiconamel", Abreviation = "Chiconamel", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30057", Name = "Chiconquiaco", Abreviation = "Chiconquiaco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30058", Name = "Chicontepec", Abreviation = "Chicontepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30059", Name = "Chinameca", Abreviation = "Chinameca", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30060", Name = "Chinampa de Gorostiza", Abreviation = "Chinampa de Gorostiza", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30061", Name = "Las Choapas", Abreviation = "Las Choapas", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30062", Name = "Chocamán", Abreviation = "Chocamán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30063", Name = "Chontla", Abreviation = "Chontla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30064", Name = "Chumatlán", Abreviation = "Chumatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30065", Name = "Emiliano Zapata", Abreviation = "Emiliano Zapata", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30066", Name = "Espinal", Abreviation = "Espinal", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30067", Name = "Filomeno Mata", Abreviation = "Filomeno Mata", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30068", Name = "Fortín", Abreviation = "Fortín", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30069", Name = "Gutiérrez Zamora", Abreviation = "Gutiérrez Zamora", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30070", Name = "Hidalgotitlán", Abreviation = "Hidalgotitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30071", Name = "Huatusco", Abreviation = "Huatusco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30072", Name = "Huayacocotla", Abreviation = "Huayacocotla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30073", Name = "Hueyapan de Ocampo", Abreviation = "Hueyapan de Ocampo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30074", Name = "Huiloapan de Cuauhtémoc", Abreviation = "Huiloapan de Cuauhtémoc", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30075", Name = "Ignacio de la Llave", Abreviation = "Ignacio de la Llave", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30076", Name = "Ilamatlán", Abreviation = "Ilamatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30077", Name = "Isla", Abreviation = "Isla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30078", Name = "Ixcatepec", Abreviation = "Ixcatepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30079", Name = "Ixhuacán de los Reyes", Abreviation = "Ixhuacán de los Reyes", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30080", Name = "Ixhuatlán del Café", Abreviation = "Ixhuatlán del Café", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30081", Name = "Ixhuatlancillo", Abreviation = "Ixhuatlancillo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30082", Name = "Ixhuatlán del Sureste", Abreviation = "Ixhuatlán del Sureste", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30083", Name = "Ixhuatlán de Madero", Abreviation = "Ixhuatlán de Madero", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30084", Name = "Ixmatlahuacan", Abreviation = "Ixmatlahuacan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30085", Name = "Ixtaczoquitlán", Abreviation = "Ixtaczoquitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30086", Name = "Jalacingo", Abreviation = "Jalacingo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30087", Name = "Xalapa", Abreviation = "Xalapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30088", Name = "Jalcomulco", Abreviation = "Jalcomulco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30089", Name = "Jáltipan", Abreviation = "Jáltipan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30090", Name = "Jamapa", Abreviation = "Jamapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30091", Name = "Jesús Carranza", Abreviation = "Jesús Carranza", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30092", Name = "Xico", Abreviation = "Xico", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30093", Name = "Jilotepec", Abreviation = "Jilotepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30094", Name = "Juan Rodríguez Clara", Abreviation = "Juan Rodríguez Clara", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30095", Name = "Juchique de Ferrer", Abreviation = "Juchique de Ferrer", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30096", Name = "Landero y Coss", Abreviation = "Landero y Coss", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30097", Name = "Lerdo de Tejada", Abreviation = "Lerdo de Tejada", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30098", Name = "Magdalena", Abreviation = "Magdalena", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30099", Name = "Maltrata", Abreviation = "Maltrata", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30100", Name = "Manlio Fabio Altamirano", Abreviation = "Manlio Fabio Altamirano", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30101", Name = "Mariano Escobedo", Abreviation = "Mariano Escobedo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30102", Name = "Martínez de la Torre", Abreviation = "Martínez de la Torre", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30103", Name = "Mecatlán", Abreviation = "Mecatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30104", Name = "Mecayapan", Abreviation = "Mecayapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30105", Name = "Medellín de Bravo", Abreviation = "Medellín de Bravo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30106", Name = "Miahuatlán", Abreviation = "Miahuatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30107", Name = "Las Minas", Abreviation = "Las Minas", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30108", Name = "Minatitlán", Abreviation = "Minatitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30109", Name = "Misantla", Abreviation = "Misantla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30110", Name = "Mixtla de Altamirano", Abreviation = "Mixtla de Altamirano", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30111", Name = "Moloacán", Abreviation = "Moloacán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30112", Name = "Naolinco", Abreviation = "Naolinco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30113", Name = "Naranjal", Abreviation = "Naranjal", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30114", Name = "Nautla", Abreviation = "Nautla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30115", Name = "Nogales", Abreviation = "Nogales", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30116", Name = "Oluta", Abreviation = "Oluta", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30117", Name = "Omealca", Abreviation = "Omealca", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30118", Name = "Orizaba", Abreviation = "Orizaba", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30119", Name = "Otatitlán", Abreviation = "Otatitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30120", Name = "Oteapan", Abreviation = "Oteapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30121", Name = "Ozuluama de Mascareñas", Abreviation = "Ozuluama de Mascareñas", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30122", Name = "Pajapan", Abreviation = "Pajapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30123", Name = "Pánuco", Abreviation = "Pánuco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30124", Name = "Papantla", Abreviation = "Papantla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30125", Name = "Paso del Macho", Abreviation = "Paso del Macho", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30126", Name = "Paso de Ovejas", Abreviation = "Paso de Ovejas", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30127", Name = "La Perla", Abreviation = "La Perla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30128", Name = "Perote", Abreviation = "Perote", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30129", Name = "Platón Sánchez", Abreviation = "Platón Sánchez", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30130", Name = "Playa Vicente", Abreviation = "Playa Vicente", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30131", Name = "Poza Rica de Hidalgo", Abreviation = "Poza Rica de Hidalgo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30132", Name = "Las Vigas de Ramírez", Abreviation = "Las Vigas de Ramírez", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30133", Name = "Pueblo Viejo", Abreviation = "Pueblo Viejo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30134", Name = "Puente Nacional", Abreviation = "Puente Nacional", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30135", Name = "Rafael Delgado", Abreviation = "Rafael Delgado", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30136", Name = "Rafael Lucio", Abreviation = "Rafael Lucio", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30137", Name = "Los Reyes", Abreviation = "Los Reyes", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30138", Name = "Río Blanco", Abreviation = "Río Blanco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30139", Name = "Saltabarranca", Abreviation = "Saltabarranca", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30140", Name = "San Andrés Tenejapan", Abreviation = "San Andrés Tenejapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30141", Name = "San Andrés Tuxtla", Abreviation = "San Andrés Tuxtla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30142", Name = "San Juan Evangelista", Abreviation = "San Juan Evangelista", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30143", Name = "Santiago Tuxtla", Abreviation = "Santiago Tuxtla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30144", Name = "Sayula de Alemán", Abreviation = "Sayula de Alemán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30145", Name = "Soconusco", Abreviation = "Soconusco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30146", Name = "Sochiapa", Abreviation = "Sochiapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30147", Name = "Soledad Atzompa", Abreviation = "Soledad Atzompa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30148", Name = "Soledad de Doblado", Abreviation = "Soledad de Doblado", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30149", Name = "Soteapan", Abreviation = "Soteapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30150", Name = "Tamalín", Abreviation = "Tamalín", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30151", Name = "Tamiahua", Abreviation = "Tamiahua", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30152", Name = "Tampico Alto", Abreviation = "Tampico Alto", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30153", Name = "Tancoco", Abreviation = "Tancoco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30154", Name = "Tantima", Abreviation = "Tantima", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30155", Name = "Tantoyuca", Abreviation = "Tantoyuca", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30156", Name = "Tatatila", Abreviation = "Tatatila", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30157", Name = "Castillo de Teayo", Abreviation = "Castillo de Teayo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30158", Name = "Tecolutla", Abreviation = "Tecolutla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30159", Name = "Tehuipango", Abreviation = "Tehuipango", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30160", Name = "Álamo Temapache", Abreviation = "Álamo Temapache", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30161", Name = "Tempoal", Abreviation = "Tempoal", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30162", Name = "Tenampa", Abreviation = "Tenampa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30163", Name = "Tenochtitlán", Abreviation = "Tenochtitlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30164", Name = "Teocelo", Abreviation = "Teocelo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30165", Name = "Tepatlaxco", Abreviation = "Tepatlaxco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30166", Name = "Tepetlán", Abreviation = "Tepetlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30167", Name = "Tepetzintla", Abreviation = "Tepetzintla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30168", Name = "Tequila", Abreviation = "Tequila", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30169", Name = "José Azueta", Abreviation = "José Azueta", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30170", Name = "Texcatepec", Abreviation = "Texcatepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30171", Name = "Texhuacán", Abreviation = "Texhuacán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30172", Name = "Texistepec", Abreviation = "Texistepec", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30173", Name = "Tezonapa", Abreviation = "Tezonapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30174", Name = "Tierra Blanca", Abreviation = "Tierra Blanca", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30175", Name = "Tihuatlán", Abreviation = "Tihuatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30176", Name = "Tlacojalpan", Abreviation = "Tlacojalpan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30177", Name = "Tlacolulan", Abreviation = "Tlacolulan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30178", Name = "Tlacotalpan", Abreviation = "Tlacotalpan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30179", Name = "Tlacotepec de Mejía", Abreviation = "Tlacotepec de Mejía", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30180", Name = "Tlachichilco", Abreviation = "Tlachichilco", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30181", Name = "Tlalixcoyan", Abreviation = "Tlalixcoyan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30182", Name = "Tlalnelhuayocan", Abreviation = "Tlalnelhuayocan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30183", Name = "Tlapacoyan", Abreviation = "Tlapacoyan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30184", Name = "Tlaquilpa", Abreviation = "Tlaquilpa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30185", Name = "Tlilapan", Abreviation = "Tlilapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30186", Name = "Tomatlán", Abreviation = "Tomatlán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30187", Name = "Tonayán", Abreviation = "Tonayán", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30188", Name = "Totutla", Abreviation = "Totutla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30189", Name = "Tuxpan", Abreviation = "Tuxpan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30190", Name = "Tuxtilla", Abreviation = "Tuxtilla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30191", Name = "Ursulo Galván", Abreviation = "Ursulo Galván", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30192", Name = "Vega de Alatorre", Abreviation = "Vega de Alatorre", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30193", Name = "Veracruz", Abreviation = "Veracruz", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30194", Name = "Villa Aldama", Abreviation = "Villa Aldama", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30195", Name = "Xoxocotla", Abreviation = "Xoxocotla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30196", Name = "Yanga", Abreviation = "Yanga", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30197", Name = "Yecuatla", Abreviation = "Yecuatla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30198", Name = "Zacualpan", Abreviation = "Zacualpan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30199", Name = "Zaragoza", Abreviation = "Zaragoza", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30200", Name = "Zentla", Abreviation = "Zentla", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30201", Name = "Zongolica", Abreviation = "Zongolica", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30202", Name = "Zontecomatlán de López y Fuentes", Abreviation = "Zontecomatlán de López y Fuentes", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30203", Name = "Zozocolco de Hidalgo", Abreviation = "Zozocolco de Hidalgo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30204", Name = "Agua Dulce", Abreviation = "Agua Dulce", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30205", Name = "El Higo", Abreviation = "El Higo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30206", Name = "Nanchital de Lázaro Cárdenas del Río", Abreviation = "Nanchital de Lázaro Cárdenas del Río", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30207", Name = "Tres Valles", Abreviation = "Tres Valles", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30208", Name = "Carlos A. Carrillo", Abreviation = "Carlos A. Carrillo", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30209", Name = "Tatahuicapan de Juárez", Abreviation = "Tatahuicapan de Juárez", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30210", Name = "Uxpanapa", Abreviation = "Uxpanapa", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30211", Name = "San Rafael", Abreviation = "San Rafael", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "30212", Name = "Santiago Sochiapan", Abreviation = "Santiago Sochiapan", IsActive = true, StateId = "30" },
                    new Domain.City() { Id = "31001", Name = "Abalá", Abreviation = "Abalá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31002", Name = "Acanceh", Abreviation = "Acanceh", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31003", Name = "Akil", Abreviation = "Akil", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31004", Name = "Baca", Abreviation = "Baca", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31005", Name = "Bokobá", Abreviation = "Bokobá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31006", Name = "Buctzotz", Abreviation = "Buctzotz", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31007", Name = "Cacalchén", Abreviation = "Cacalchén", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31008", Name = "Calotmul", Abreviation = "Calotmul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31009", Name = "Cansahcab", Abreviation = "Cansahcab", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31010", Name = "Cantamayec", Abreviation = "Cantamayec", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31011", Name = "Celestún", Abreviation = "Celestún", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31012", Name = "Cenotillo", Abreviation = "Cenotillo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31013", Name = "Conkal", Abreviation = "Conkal", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31014", Name = "Cuncunul", Abreviation = "Cuncunul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31015", Name = "Cuzamá", Abreviation = "Cuzamá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31016", Name = "Chacsinkín", Abreviation = "Chacsinkín", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31017", Name = "Chankom", Abreviation = "Chankom", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31018", Name = "Chapab", Abreviation = "Chapab", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31019", Name = "Chemax", Abreviation = "Chemax", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31020", Name = "Chicxulub Pueblo", Abreviation = "Chicxulub Pueblo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31021", Name = "Chichimilá", Abreviation = "Chichimilá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31022", Name = "Chikindzonot", Abreviation = "Chikindzonot", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31023", Name = "Chocholá", Abreviation = "Chocholá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31024", Name = "Chumayel", Abreviation = "Chumayel", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31025", Name = "Dzán", Abreviation = "Dzán", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31026", Name = "Dzemul", Abreviation = "Dzemul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31027", Name = "Dzidzantún", Abreviation = "Dzidzantún", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31028", Name = "Dzilam de Bravo", Abreviation = "Dzilam de Bravo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31029", Name = "Dzilam González", Abreviation = "Dzilam González", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31030", Name = "Dzitás", Abreviation = "Dzitás", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31031", Name = "Dzoncauich", Abreviation = "Dzoncauich", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31032", Name = "Espita", Abreviation = "Espita", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31033", Name = "Halachó", Abreviation = "Halachó", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31034", Name = "Hocabá", Abreviation = "Hocabá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31035", Name = "Hoctún", Abreviation = "Hoctún", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31036", Name = "Homún", Abreviation = "Homún", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31037", Name = "Huhí", Abreviation = "Huhí", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31038", Name = "Hunucmá", Abreviation = "Hunucmá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31039", Name = "Ixil", Abreviation = "Ixil", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31040", Name = "Izamal", Abreviation = "Izamal", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31041", Name = "Kanasín", Abreviation = "Kanasín", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31042", Name = "Kantunil", Abreviation = "Kantunil", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31043", Name = "Kaua", Abreviation = "Kaua", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31044", Name = "Kinchil", Abreviation = "Kinchil", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31045", Name = "Kopomá", Abreviation = "Kopomá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31046", Name = "Mama", Abreviation = "Mama", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31047", Name = "Maní", Abreviation = "Maní", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31048", Name = "Maxcanú", Abreviation = "Maxcanú", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31049", Name = "Mayapán", Abreviation = "Mayapán", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31050", Name = "Mérida", Abreviation = "Mérida", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31051", Name = "Mocochá", Abreviation = "Mocochá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31052", Name = "Motul", Abreviation = "Motul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31053", Name = "Muna", Abreviation = "Muna", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31054", Name = "Muxupip", Abreviation = "Muxupip", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31055", Name = "Opichén", Abreviation = "Opichén", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31056", Name = "Oxkutzcab", Abreviation = "Oxkutzcab", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31057", Name = "Panabá", Abreviation = "Panabá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31058", Name = "Peto", Abreviation = "Peto", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31059", Name = "Progreso", Abreviation = "Progreso", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31060", Name = "Quintana Roo", Abreviation = "Quintana Roo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31061", Name = "Río Lagartos", Abreviation = "Río Lagartos", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31062", Name = "Sacalum", Abreviation = "Sacalum", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31063", Name = "Samahil", Abreviation = "Samahil", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31064", Name = "Sanahcat", Abreviation = "Sanahcat", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31065", Name = "San Felipe", Abreviation = "San Felipe", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31066", Name = "Santa Elena", Abreviation = "Santa Elena", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31067", Name = "Seyé", Abreviation = "Seyé", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31068", Name = "Sinanché", Abreviation = "Sinanché", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31069", Name = "Sotuta", Abreviation = "Sotuta", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31070", Name = "Sucilá", Abreviation = "Sucilá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31071", Name = "Sudzal", Abreviation = "Sudzal", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31072", Name = "Suma", Abreviation = "Suma", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31073", Name = "Tahdziú", Abreviation = "Tahdziú", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31074", Name = "Tahmek", Abreviation = "Tahmek", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31075", Name = "Teabo", Abreviation = "Teabo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31076", Name = "Tecoh", Abreviation = "Tecoh", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31077", Name = "Tekal de Venegas", Abreviation = "Tekal de Venegas", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31078", Name = "Tekantó", Abreviation = "Tekantó", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31079", Name = "Tekax", Abreviation = "Tekax", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31080", Name = "Tekit", Abreviation = "Tekit", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31081", Name = "Tekom", Abreviation = "Tekom", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31082", Name = "Telchac Pueblo", Abreviation = "Telchac Pueblo", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31083", Name = "Telchac Puerto", Abreviation = "Telchac Puerto", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31084", Name = "Temax", Abreviation = "Temax", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31085", Name = "Temozón", Abreviation = "Temozón", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31086", Name = "Tepakán", Abreviation = "Tepakán", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31087", Name = "Tetiz", Abreviation = "Tetiz", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31088", Name = "Teya", Abreviation = "Teya", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31089", Name = "Ticul", Abreviation = "Ticul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31090", Name = "Timucuy", Abreviation = "Timucuy", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31091", Name = "Tinum", Abreviation = "Tinum", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31092", Name = "Tixcacalcupul", Abreviation = "Tixcacalcupul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31093", Name = "Tixkokob", Abreviation = "Tixkokob", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31094", Name = "Tixmehuac", Abreviation = "Tixmehuac", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31095", Name = "Tixpéhual", Abreviation = "Tixpéhual", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31096", Name = "Tizimín", Abreviation = "Tizimín", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31097", Name = "Tunkás", Abreviation = "Tunkás", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31098", Name = "Tzucacab", Abreviation = "Tzucacab", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31099", Name = "Uayma", Abreviation = "Uayma", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31100", Name = "Ucú", Abreviation = "Ucú", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31101", Name = "Umán", Abreviation = "Umán", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31102", Name = "Valladolid", Abreviation = "Valladolid", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31103", Name = "Xocchel", Abreviation = "Xocchel", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31104", Name = "Yaxcabá", Abreviation = "Yaxcabá", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31105", Name = "Yaxkukul", Abreviation = "Yaxkukul", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "31106", Name = "Yobaín", Abreviation = "Yobaín", IsActive = true, StateId = "31" },
                    new Domain.City() { Id = "32001", Name = "Apozol", Abreviation = "Apozol", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32002", Name = "Apulco", Abreviation = "Apulco", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32003", Name = "Atolinga", Abreviation = "Atolinga", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32004", Name = "Benito Juárez", Abreviation = "Benito Juárez", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32005", Name = "Calera", Abreviation = "Calera", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32006", Name = "Cañitas de Felipe Pescador", Abreviation = "Cañitas de Felipe Pescador", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32007", Name = "Concepción del Oro", Abreviation = "Concepción del Oro", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32008", Name = "Cuauhtémoc", Abreviation = "Cuauhtémoc", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32009", Name = "Chalchihuites", Abreviation = "Chalchihuites", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32010", Name = "Fresnillo", Abreviation = "Fresnillo", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32011", Name = "Trinidad García de la Cadena", Abreviation = "Trinidad García de la Cadena", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32012", Name = "Genaro Codina", Abreviation = "Genaro Codina", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32013", Name = "General Enrique Estrada", Abreviation = "General Enrique Estrada", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32014", Name = "General Francisco R. Murguía", Abreviation = "General Francisco R. Murguía", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32015", Name = "El Plateado de Joaquín Amaro", Abreviation = "El Plateado de Joaquín Amaro", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32016", Name = "General Pánfilo Natera", Abreviation = "General Pánfilo Natera", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32017", Name = "Guadalupe", Abreviation = "Guadalupe", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32018", Name = "Huanusco", Abreviation = "Huanusco", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32019", Name = "Jalpa", Abreviation = "Jalpa", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32020", Name = "Jerez", Abreviation = "Jerez", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32021", Name = "Jiménez del Teul", Abreviation = "Jiménez del Teul", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32022", Name = "Juan Aldama", Abreviation = "Juan Aldama", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32023", Name = "Juchipila", Abreviation = "Juchipila", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32024", Name = "Loreto", Abreviation = "Loreto", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32025", Name = "Luis Moya", Abreviation = "Luis Moya", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32026", Name = "Mazapil", Abreviation = "Mazapil", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32027", Name = "Melchor Ocampo", Abreviation = "Melchor Ocampo", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32028", Name = "Mezquital del Oro", Abreviation = "Mezquital del Oro", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32029", Name = "Miguel Auza", Abreviation = "Miguel Auza", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32030", Name = "Momax", Abreviation = "Momax", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32031", Name = "Monte Escobedo", Abreviation = "Monte Escobedo", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32032", Name = "Morelos", Abreviation = "Morelos", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32033", Name = "Moyahua de Estrada", Abreviation = "Moyahua de Estrada", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32034", Name = "Nochistlán de Mejía", Abreviation = "Nochistlán de Mejía", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32035", Name = "Noria de Ángeles", Abreviation = "Noria de Ángeles", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32036", Name = "Ojocaliente", Abreviation = "Ojocaliente", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32037", Name = "Pánuco", Abreviation = "Pánuco", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32038", Name = "Pinos", Abreviation = "Pinos", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32039", Name = "Río Grande", Abreviation = "Río Grande", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32040", Name = "Sain Alto", Abreviation = "Sain Alto", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32041", Name = "El Salvador", Abreviation = "El Salvador", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32042", Name = "Sombrerete", Abreviation = "Sombrerete", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32043", Name = "Susticacán", Abreviation = "Susticacán", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32044", Name = "Tabasco", Abreviation = "Tabasco", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32045", Name = "Tepechitlán", Abreviation = "Tepechitlán", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32046", Name = "Tepetongo", Abreviation = "Tepetongo", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32047", Name = "Teúl de González Ortega", Abreviation = "Teúl de González Ortega", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32048", Name = "Tlaltenango de Sánchez Román", Abreviation = "Tlaltenango de Sánchez Román", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32049", Name = "Valparaíso", Abreviation = "Valparaíso", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32050", Name = "Vetagrande", Abreviation = "Vetagrande", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32051", Name = "Villa de Cos", Abreviation = "Villa de Cos", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32052", Name = "Villa García", Abreviation = "Villa García", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32053", Name = "Villa González Ortega", Abreviation = "Villa González Ortega", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32054", Name = "Villa Hidalgo", Abreviation = "Villa Hidalgo", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32055", Name = "Villanueva", Abreviation = "Villanueva", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32056", Name = "Zacatecas", Abreviation = "Zacatecas", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32057", Name = "Trancoso", Abreviation = "Trancoso", IsActive = true, StateId = "32" },
                    new Domain.City() { Id = "32058", Name = "Santa María de la Paz", Abreviation = "Santa María de la Paz", IsActive = true, StateId = "32" }
                );
            }
            _context.SaveChanges();
        }
    }
}
